
(function() {
	// Test support of transistions
	$.support.transition = (function() {
		var thisBody = document.body || document.documentElement,
			support = 'transition' in thisBody.style ||
				'WebkitTransition' in thisBody.style ||
				'MozTransition' in thisBody.style ||
				'msTransition' in thisBody.style ||
				'MsTransition' in thisBody.style ||
				'OTransition' in thisBody.style;
		// Disable all fields that require pointer-events, if not supported
		if ( !support ) {
			$( "body" ).addClass( "disable-pointer-events" );
		}
		return support; 
	})();
	// Test support of transistions
	$.support.animation = (function() {
		var thisBody = document.body || document.documentElement,
			support = 'animation' in thisBody.style ||
				'WebkitAnimation' in thisBody.style ||
				'MozAnimation' in thisBody.style ||
				'msAnimation' in thisBody.style ||
				'MsAnimation' in thisBody.style ||
				'OAnimation' in thisBody.style;
		// Disable all fields that require animations events, if not supported
		if ( !support ) {
			$( "body" ).addClass( "disable-animation" );
		}
		return support; 
	})();
	// Test support of pointer-events
	$.support.pointerEvents = (function() {
		var element = document.createElement( "x" );
		element.style.cssText = "pointer-events: auto;";
		return element.style.pointerEvents === "auto";
	})();
	// Test support of multiple background images
	$.support.multipleBackgrounds = (function() {
		var element = document.createElement( "div" );
		element.style.cssText = "background:url(//:),url(//:),red url(//:)";
		// If the UA supports multiple backgrounds, there should be three occurrences
		// of the string "url(" in the return value for el_style.background
		return new RegExp( "(url\\s*\\(.*?){3}" ).test( element.style.background );
	})();
	$.fn.extend({
		// Animate toggling classes, that does not support transitions
		toggleClasses: (function( orig ) {
			return function( classNames, force, speed, easing, callback ) {
				var transitionStyle = $.fn.css.call( this, "transition" ),
					transitionArgs,
					transitionSpeed,
					hasSpeed = ( ( ( typeof force === "boolean" || force === undefined ) && speed ) || ( ( typeof force !== "boolean" && force !== undefined ) && force ) );
				if ( transitionStyle && !$.support.transition && !hasSpeed ) {
					transitionArgs = ( " " + transitionStyle.toString() + " " ).toLowerCase().replace( /,/, " " ).match( / ([0-9\.]+)(m?s) / );
					transitionSpeed = parseInt( ( transitionArgs[ 2 ] === "s" ? ( transitionArgs[ 1 ] * 1000 ) : transitionArgs[ 1 ] ), 10 );
					if ( typeof force === "boolean" || force === undefined ) {
						if ( !speed && transitionSpeed ) {
							if ( force !== undefined ) {
								return orig.call( this, classNames, force, transitionSpeed, easing, callback );
							} else {
								return orig.call( this, classNames, transitionSpeed, speed, easing );
							}
						}
					} else {
						if ( !force && transitionSpeed ) {
							return orig.call( this, classNames, transitionSpeed, speed, easing );
						}
					}
				}
				return orig.apply( this, arguments );
			};
		})( $.fn.toggleClass )
	});
})();

$(function() {
	// Add click events
	$( "#header-tool" ).bind( "click", function() {
		$( "#toolbox" ).toggleClasses( "active", true );
	});
	$( "#toolbox-close" ).bind( "click", function() {
		$( "#toolbox" ).toggleClasses( "active", false );
	});
	$( "#header-login > a" ).bind( "click", function() {
		if ( $( this ).attr( "href" ) ) {
			return true;
		} else {
			$( "#login" ).toggleClasses( "active", true );
			return false;
		}
	});
	$( "#login-close" ).bind( "click", function() {
		$( "#login" ).toggleClasses( "active", false );
	});
	// Open login on click in navigation field, scroll to top
	$( "#content-navi a[href$=\"/login/\"]" ).bind( "click", function( event ) {
		event.preventDefault();
		$( "html,body" ).animate({
			scrollTop: 0
		}, 200, function() {
			$( "#header-login > a" ).trigger( "click" );
		});
	});
	// Open toolbox on click in pagination field, scroll to top
	$( ".content-pagination.tools a" ).bind( "click", function( event ) {
		event.preventDefault();
		$( "html,body" ).animate({
			scrollTop: 0
		}, 200, function() {
			$( "#header-tool" ).trigger( "click" );
		});
	});
	// Hide login and toolbox on focussing search field and resize the field
	$( "#header-search input[type=\"search\"], #header-search input[type=\"text\"]" ).bind( "focus", function() {
		$( "#login" ).toggleClasses( "active", false );
		$( "#toolbox" ).toggleClasses( "active", false );
		$( "#header" ).addClass( "searchfocus" );
		window.setTimeout(function() {
			$( ".ui-autocomplete-input" ).autocomplete( "search" );	
		}, ( $.support.transition ? 300 : 1 ) );
	}).bind( "blur", function() {
		$( "#header" ).removeClass( "searchfocus" );
	});
	// Adding search query to url, for Google Analytics
	$( "#header-search form" ).bind( "submit", function( event ) {
		var searchUrl = $( this ).attr( "action" ) || document.location.href,
			searchField = $( this ).find( "input[type=\"search\"], input[type=\"text\"]" ).last(),
			searchValue = $.trim( searchField.val() );
		if ( typeof( searchValue ) != 'string' || searchValue === '' ) {
			event.preventDefault();
			return false;
		} else {
			searchUrl += searchUrl.indexOf( "?" ) == -1 ? "?" : "";
			searchUrl += searchField.attr( "name" ) + "=" + searchValue;
			$( this ).attr( "action", searchUrl );
			return true;
		}
	});
	// Content-navi splider, mobile
	if ( "ontouchstart" in document.documentElement ) {
		var sliderElem = $( "#content-navi .slider" ),
			lastElem = $( "#content-navi .slider li:visible:last" ),
			width = lastElem.offset().left + lastElem.outerWidth( true ) - sliderElem.offset().left,
			myScroll;
		sliderElem.children( "ul" ).width( width ).wrap( "<div class=\"wrapper\" style=\"width: " + width + "px;\">" );
		myScroll = new iScroll( $( "#content-navi .slider" )[ 0 ], {
			vScroll: false,
			useTransition: true,
			hScrollbar: false
		 });
		 $( "#content-navi .control" ).bind( "touchend", function() {
			if ( $( this ).hasClass( "control-prev" ) ) {
				myScroll.scrollTo( ( lastElem.outerWidth( true ) * -1 ), 0, 200, true );
			} else if( $( this ).hasClass( "control-next" ) ) {
				myScroll.scrollTo( lastElem.outerWidth( true ), 0, 200, true );
			}
		 });
	// Content-navi splider, desktop
	} else {
		$( "[data-jcarousel]" ).each(function() {
			var el = $( this );
			el.data( "transitions", $.support.transition );
			el.jcarousel( el.data() );
		});
		$( "[data-jcarousel-autoscroll]" ).each(function() {
			var el = $( this );
			el.jcarouselAutoscroll( el.data() );
		});
		$( "[data-jcarousel-control]" ).each(function() {
			var el = $( this );
			el.bind( "mouseenter", function() {
				el.closest( "nav" ).find( "[data-jcarousel]" ).each(function() {
					var elC = $( this );
					elC.jcarouselAutoscroll( "reload" , el.data() );
					elC.jcarouselAutoscroll( "start" );
				});
			}).bind( "mouseleave", function() {
				el.closest( "nav" ).find( "[data-jcarousel]" ).each(function() {
					var elC = $( this );
					elC.jcarouselAutoscroll( "stop");
				});
			});
		});
	}
	// Add button to csc-frame-1
	$( ".csc-frame-frame1" ).each(function() {
		var button = $( "<a />" ).addClass( "csc-frame-frame1-button" ).bind( "click", function() {
			$( this ).parent( ".csc-frame-frame1" ).toggleClasses( "active" );
		});
		$( this ).prepend( button );
	});
	// Hide browserwarning on click
	$( "#browserwarning .cls" ).bind( "click", function() {
		$( "#browserwarning" ).slideUp( "fast", function() {
			$( this ).remove();
		});
	});
	// Facebook Opt-Out
	$( "a.fbOptoutLink" ).bind( "click", function( event ) {
		event.preventDefault();
		event.stopPropagation();
		document.cookie = "fb-disable=yes; expires=Thu, 31 Dec 2099 23:59:59 UTC; path=/";
		return false;
	});
});

if ( $.support.animation ) {
	// Defining new loader for lightbox
	function tb_load( show ) {
		var loader = $( "#loading" ),
			overlay = $( "#TB_overlay" ),
			events = [ "webkitAnimationEnd", "oanimationend", "mozAnimationEnd", "msAnimationEnd", "animationend" ];
		if ( show ) {
			if ( overlay.length > 0 ) {
				loader.show();
				overlay.hide();
			} else {
				loader.addClass( "fadein" ).show().one( events.join( " " ), function() {
					$( this ).removeClass( "fadein" );
				});
			}
		} else {
			if ( overlay.length > 0 ) {
				overlay.show();
				loader.hide();
			} else {
				loader.addClass( "fadeout" ).one( events.join( " " ), function() {
					$( this ).hide().removeClass( "fadeout" );
				});
			}
		}
	}
	var ignoreUnload = false;
	$( "body" ).delegate( "a[href], a[target]", "click", function() {
		var href = $( this ).attr( "href" ) || "",
			target = $( this ).attr( "target" ) || "",
			linkMail = ( href.length > 0 ? href.match( /^(mailto:|javascript:linkTo_UnCryptMailto)/i ) : false ),
			linkJumpurl = ( href.length > 0 ? href.match( /jumpurl=/ ) : false ),
			linkTarget = ( target.length > 0 ? !target.match( /^(_top|_parent)$/i ) : false );
		if ( linkMail || linkJumpurl || linkTarget ) {
			ignoreUnload = true;
		}
	});
	// Open new loader on unloading page
	$( window ).bind( "beforeunload unload", function( event ) {
		if ( !ignoreUnload ) {
			tb_load( true );
		} else {
			ignoreUnload = false;
		}
	});
}

$( window ).load(function() {
	// Rescale font-sizes
	$( ".content-pagination > .scale" ).textfill({
		maxFontPixels: 18,
		explicitHeight: $( ".content-pagination" ).height()
	}).css({
		fontSize: $( ".content-pagination > .scale > span:visible:first" ).css( "fontSize" )
	});
	$( ".content-pagetitle > h1" ).textfill({
		maxFontPixels: 32,
		explicitHeight: $( ".content-pagetitle" ).height()
	}).css({
		fontSize: $( ".content-pagetitle > h1 > span:visible:first" ).css( "fontSize" )
	});
	$( ".content-pagination-sub li > a" ).textfill({
		maxFontPixels: 18,
		widthOnly: true
	}).each(function() {
		$( this ).css({
			fontSize: $( this ).children( "span:visible:first" ).css( "fontSize" )
		});
	});
	// Hide loading status, when page is loaded
	if ( $.support.animation ) {
		tb_load( false );
	}
});
