(function($) {
	$.fn.cssNum = function() {
		return parseFloat($.fn.css.apply(this, arguments)) || 0;
	};
	$.extend({
		'explode': function() {
			var delim = arguments[0] || null,
				string = arguments[1] || null,
				limit = arguments[2] || 0;
			if (delim === null || string === null) {
				console.error('$.explode() needs argument 0 and argument 1 to be string');
				return [];
			}
			if (!limit) {
				return string.split(delim);
			} else {
				// support for limit argument
				var splitted = string.split(delim);
				var partA = splitted.splice(0, limit - 1);
				var partB = splitted.join(delim);
				partA.push(partB);
				return partA;
			}
		},
		'validEmail': function() {
			var email = arguments[0] || '',
				mailRegExp = new RegExp(/^(("[\w-+\s]+")|([\w-+]+(?:\.[\w-+]+)*)|("[\w-+\s]+")([\w-+]+(?:\.[\w-+]+)*))(@((?:[\w-+]+\.)*\w[\w-+]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$)|(@\[?((25[0-5]\.|2[0-4][\d]\.|1[\d]{2}\.|[\d]{1,2}\.))((25[0-5]|2[0-4][\d]|1[\d]{2}|[\d]{1,2})\.){2}(25[0-5]|2[0-4][\d]|1[\d]{2}|[\d]{1,2})\]?$)/i);
			return mailRegExp.test(email) ? true : false;
		},
		'preg_quote': function() {
			// Quote regular expression characters plus an optional character  
			// 
			// version: 1109.2015
			// discuss at: http://phpjs.org/functions/preg_quote
			// +   original by: booeyOH
			// +   improved by: Ates Goral (http://magnetiq.com)
			// +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
			// +   bugfixed by: Onno Marsman
			// +   improved by: Brett Zamir (http://brett-zamir.me)
			// *     example 1: preg_quote("$40");
			// *     returns 1: '\$40'
			// *     example 2: preg_quote("*RRRING* Hello?");
			// *     returns 2: '\*RRRING\* Hello\?'
			// *     example 3: preg_quote("\\.+*?[^]$(){}=!<>|:");
			// *     returns 3: '\\\.\+\*\?\[\^\]\$\(\)\{\}\=\!\<\>\|\:'
			var str = arguments[0] || '',
				delimiter = arguments[1] || '',
				quotedbl = arguments[2] || '';
			return (str + '').replace(new RegExp('[.\\\\+*?\\[\\^\\]$(){}=!<>|:\\' + (delimiter || '') + '-]', 'g'), (quotedbl ? '\\' : '') + '\\$&');
		}
	});
}(jQuery));


var tx_p123qsearch_pi1 = {
	errorWindow: function(message, button){alert(message);},
	displayLoader: function(show){},	
};

var tx_p123search_pi3 = {
	afterSearch: [],
	getHash: function(string) {
		var hash = (document.location.hash.length > 1) ? decodeURI(document.location.hash).substr(1).split('/') : [];
		for (var i = 0; i < hash.length; i++) {
			if ($.trim(hash[i]).length < 2) {
				continue;
			}
			var hashItem = hash[i].split(':', 2);
			if ($.trim(hashItem[0]).toLowerCase() == string.toLowerCase()) {
				return $.trim(hashItem[1]);
			}
		}
		return null;
	},
	setHash: function(key, value) {
		var hash = (document.location.hash.length > 1) ? document.location.hash.substr(1).split('/') : [],
			newHash = [],
			replaced = false;
		for (var i = 0; i < hash.length; i++) {
			if ($.trim(hash[i]).length < 1) {
				continue;
			}
			var hashItem = hash[i].split(':', 2);
			if ($.trim(hashItem[0]).toLowerCase() == key.toLowerCase()) {
				newHash.push(key + ':' + value);
				replaced = true;
			} else {
				newHash.push($.trim(hashItem[0] + ':' + hashItem[1]));
			}
		}
		if (!replaced) {
			newHash.push(key + ':' + value);
		}
		if (typeof(history.replaceState) == 'function') {
			history.replaceState(null, document.title, '#' + encodeURI(newHash.join('/')));
		} else {
			document.location.hash = encodeURI(newHash.join('/'));
		}
		return newHash.join('/');
	},
	removeHash: function(key, value) {
		var hash = (document.location.hash.length > 1) ? document.location.hash.substr(1).split('/') : [],
			newHash = [];
		for (var i = 0; i < hash.length; i++) {
			if ($.trim(hash[i]).length < 1) {
				continue;
			}
			var hashItem = hash[i].split(':', 2);
			if ($.trim(hashItem[0]).toLowerCase() == key.toLowerCase()) {
				if (typeof(value) != 'undefined') {
					if ($.trim(hashItem[1]).toLowerCase() == value.toLowerCase()) {
						continue;
					}
				} else {
					continue;
				}
			}
			newHash.push($.trim(hashItem[0] + ':' + hashItem[1]));
		}
		if (typeof(history.replaceState) == 'function') {
			history.replaceState(null, document.title, '#' + newHash.join('/'));
		} else {
			document.location.hash = newHash.join('/');
		}
		return newHash.join('/');
	},	
};
