<?php
namespace CAWmedia\Cawlogin\ViewHelpers;

use TYPO3\CMS\Core\Utility\GeneralUtility;

/**
 * @author Dennis Robota-Özet <info@doemedia.de>
 */
class AssetViewHelper extends \TYPO3\CMS\Fluid\Core\ViewHelper\AbstractViewHelper {

    /**
     * @param  string $table
     * @param  int $uid
     * @param  string $field
     * @param  string $as
     * @param  boolean $showHiddenRecords
     * @return string
     */
    public function render($uid, $table = 'tt_content', $field = 'assets', $as = 'asset', $showHiddenRecords = FALSE) {

        $content = '';

        if(!is_int($uid)) {
            $uid = intval($uid);
        }

        if($uid > 0) {
            $fileRepository = GeneralUtility::makeInstance(\TYPO3\CMS\Core\Resource\FileRepository::class);

            // this is need, otherwise it will render disabled items if a backend user is logged in
            $_showHiddenRecords = $GLOBALS['TSFE']->showHiddenRecords;
            $GLOBALS['TSFE']->showHiddenRecords = $showHiddenRecords;

            $fileObjects = $fileRepository->findByRelation($table, $field, $uid);

            // Reset
            $GLOBALS['TSFE']->showHiddenRecords = $_showHiddenRecords;

            $this->templateVariableContainer->add($as, $fileObjects);
            $content = $this->renderChildren();
            $this->templateVariableContainer->remove($as);
        }


        return $content;
    }

}