<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2008 Jan Roemich <jroemich@dpi-one.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
/**
 * LOGIN // LOGOUT
 *
 *
 *
 *   71: class tx_cawlogin_pi extends tslib_pibase
 *
 *              SECTION: Main function
 *  113:     function init()
 *  139:     function main($content, $conf)
 *
 * TOTAL FUNCTIONS: 1
 *
 */

























/**
 * Plugin 'CAW Login Logout' for the 'caw_login' extension.
 *
 * @author	Jan Roemich <jroemich@dpi-one.de>
 * @package	TYPO3
 * @subpackage	tx_cawlogin
 */
class tx_cawlogin_pi extends \TYPO3\CMS\Frontend\Plugin\AbstractPlugin {
    public $prefixId = 'tx_cawlogin_pi';		// Same as class name
    public $scriptRelPath = 'plugins/pi/class.tx_cawlogin_pi.php';	// Path to this script relative to the extension dir.
    public $extKey = 'cawlogin';	// The extension key.
    /**
     * New instance of t3lib_db
     *
     * @var t3lib_DB
     */
    public $db = FALSE; // Database handle for external database
    protected $extConf = array();
    public $data = array();
    public $session = array();
    public $invalid = FALSE; // Set to TRUE, if an error occurs
    public $requiredData = '';
    public $insertData = '';
    public $pageRenderer = null;





    /**
     * The init method of the plugin
     *
     * @return	void
     */
    protected function init() {
        $this->extConf = unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf'][$this->extKey]);
        // Get an new instance for the database connection
        $this->db = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(\TYPO3\CMS\Core\Database\DatabaseConnection::class);
        // Debugging is enabled
        if (\TYPO3\CMS\Core\Utility\GeneralUtility::inList($this->conf['debug'], $_SERVER['REMOTE_ADDR'])) {
            $this->db->debugOutput = $this->db->store_lastBuiltQuery = TRUE;
        }
        // Connect to the database
        $this->pi_DBconnect($this->extConf['host'], $this->extConf['user'], $this->extConf['pass'], $this->extConf['table']);

        // Load the session data
        $this->pi_SESload();

        $this->pageRenderer = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(\TYPO3\CMS\Core\Page\PageRenderer::class);

        // Logout and re-login if requested
        $piVars = \TYPO3\CMS\Core\Utility\GeneralUtility::_POST('tx_cawlogin_pi1');
        if ($GLOBALS['TSFE']->loginUser && $piVars['mode'] == 'login' && isset($piVars['ordernr']) && isset($piVars['password'])) {
            $this->logout();
            header('HTTP/1.1 307 Temporary Redirect');
            $this->pi_redirect($this->conf['loginPage']);
            // Check the login
        } else if ($GLOBALS['TSFE']->loginUser || ($this->session['ordernr'] && $this->session['password'])) {
            // If login is invalid, the user out and redirect to login-page
            if (!$this->checkLogin($this->session['ordernr'], $this->session['password'])) {
                $this->logout();
                $this->pi_redirect($GLOBALS['TSFE']->id);
            }
        }
    }




    /**
     * The checkLogin method of the PlugIn
     * 3c8d3f224e5ae2f3f742200efd7bc857
     * @param	integer		$intNo: The order number
     * @param	string		$password: The password
     * @return	True if the user data is correct. Else false
     */
    protected function checkLogin($intNo, $strPassword) {
        // Syntax is not valid
        if (!preg_match('/^[0-9]{3,}$/', $intNo) || !$strPassword) {
            return FALSE;
        }
        // Administrator has logged in
        if (MD5($intNo) == MD5('0061124') && MD5($strPassword) == MD5('!QRGWxksp*an')) {
            return TRUE;
        }
        // Convert password to ISO-8859-1
        $strPassword = $GLOBALS['TSFE']->csConvObj->conv($strPassword, $GLOBALS['TSFE']->renderCharset, 'iso-8859-1');
        // Login is not found in database
        $mixRes = $this->db->exec_SELECTquery(
            '*',
            'Login_auftrag',
            'auftrag_nummer='.$this->db->fullQuoteStr($intNo, 'Login_auftrag').' AND auftrag_passwort=MD5('.$this->db->fullQuoteStr($strPassword, 'Login_auftrag').')'
        );

        return ($this->db->sql_num_rows($mixRes) == 1) ? TRUE : FALSE;
    }





    /**
     * The loginAndRedirect method of the PlugIn
     *
     * @param	integer		$intNo: The order number
     * @param	string		$strPassword: The password
     * @return	void
     */
    protected function login($intNo, $strPassword) {
        // Administrator has logged in
        if (MD5($intNo) == MD5('0061124') && MD5($strPassword) == MD5('!QRGWxksp*an')) {
            $user = $GLOBALS['TSFE']->fe_user->getRawUserByUid((int)$this->conf['fe_admin']);
        } else {
            $this->db->exec_UPDATEquery('Login_auftrag', 'auftrag_nummer='.$this->db->fullQuoteStr($intNo, 'Login_auftrag'), array('auftrag_letzter_besuch' => time()));
            $user = $GLOBALS['TSFE']->fe_user->getRawUserByUid((int)$this->conf['fe_user']);
        }
        // Set login data
        if (is_array($user)) {
            $_POST['logintype'] = 'login';
            $_POST['user'] = $user['username'];
            //$_POST['pass'] = $user['password'];
            //doemedia: We need original password to log in
            $_POST['pass'] = $user['username'];
            $_POST['pid'] = $user['pid'];

            // Login the user
            $GLOBALS['TSFE']->initFEuser();
            $GLOBALS['TSFE']->initUserGroups();
            $GLOBALS['TSFE']->storeSessionData();

            // Save the ordernumber and the password to the session
            $this->session['isAdmin'] = ($user['uid'] == $this->conf['fe_admin']) ? 1 : 0;
            $this->session['ordernr'] = (string)$intNo;
            $this->session['password'] = $strPassword;

//            die('#');

            // Save the session
            $this->pi_SESsave();
        }
    }





    /**
     * The logout method of the PlugIn
     *
     * @return	void
     */
    protected function logout() {
        $GLOBALS['TSFE']->fe_user->logoff();
        $GLOBALS['TSFE']->initUserGroups();
        $GLOBALS['TSFE']->storeSessionData();
        $this->session = null;
        $this->pi_SESsave();
    }























    /***************************
     *
     * Check the referer
     *
     **************************/



    /**
     * Check the referer data for validation
     *
     * @return	boolean		Returns TRUE, if the referer is empty or the site url, else FALSE
     */
    function referer()	{
        // No referer is set
        if (!\TYPO3\CMS\Core\Utility\GeneralUtility::getIndpEnv('HTTP_REFERER')) {
            return TRUE;
        }
        // Referer comes from current site url
        if (substr(\TYPO3\CMS\Core\Utility\GeneralUtility::getIndpEnv('HTTP_REFERER'), 0, strlen(\TYPO3\CMS\Core\Utility\GeneralUtility::getIndpEnv('TYPO3_SITE_URL'))) == \TYPO3\CMS\Core\Utility\GeneralUtility::getIndpEnv('TYPO3_SITE_URL')) {
            return TRUE;
        }
        return FALSE;
    }

















    /***************************
     *
     * Various functions
     *
     **************************/


    /**
     * Redirect to an internal or external page, the page id or a full link can be given.
     *
     * @param	int/string	$page: The page that is redirected to
     * @param	boolean		$condition: condition if redirect or not
     * @return	void
     */
    protected function pi_redirect($mixPage, $bolCondition=TRUE) {
        //redirect only if the condition is true
        if ($bolCondition) {
            $this->pi_SESsave();
            // Test, if the page is internal or external
            if (\TYPO3\CMS\Core\Utility\MathUtility::canBeInterpretedAsInteger($mixPage)) {
                $mixLinkData = $GLOBALS['TSFE']->sys_page->getPage_noCheck($mixPage);
                $mixLD = $GLOBALS['TSFE']->tmpl->linkData($mixLinkData, '', '', '', '', $this->cObj->getClosestMPvalueForPage($mixLinkData['uid']));
                $mixPage = $mixLD['totalURL'];
            }
            // If the page is an integer its the page id, else it is an URI
            header('Location: '.\TYPO3\CMS\Core\Utility\GeneralUtility::locationHeaderUrl($mixPage));
            exit;
        }
    }

    /**
     * Save content into an file
     *
     * @param	string		$strPath: The path to save the content
     * @param	string		$strFilename: The filename to save the content
     * @param 	string		$strContent: The content to write to the file
     * @return	void
     */
    protected function pi_saveIntoFile($strPath, $strFilename, $strContent) {
        $mixFp = fopen($strPath.$strFilename, 'w');
        fwrite($mixFp, $strContent);
        fclose($mixFp);
    }

















    /***************************
     *
     * Database functions
     *
     **************************/


    /**
     * Open connection to the external MySQL Database
     *
     * @param	string		$strHost: Database host
     * @param	string		$strUsername: Database username
     * @param	string		$strPassword: Database password
     * @param	string		$strDatabase: Database table
     * @return	void
     */
    private function pi_DBconnect($strHost, $strUsername, $strPassword, $strDatabase)	{
        //doemedia begin
        $this->db->setDatabaseHost($strHost);
        $this->db->setDatabaseUsername($strUsername);
        $this->db->setDatabasePassword($strPassword);
        $this->db->setDatabaseName($strDatabase);
        $this->db->setPersistentDatabaseConnection(true);
        $this->db->setConnectionCompression(true);
        //doemedia end

        if ($this->db->sql_pconnect($strHost, $strUsername, $strPassword))	{
            if (!$strDatabase)	{
                die('No database selected');
                exit;
            } elseif (!$this->db->sql_select_db($strDatabase))	{
                die('Cannot connect to the current database, "'.$strDatabase.'"');
                exit;
            }
        } else {
            die('The current username, password or host was not accepted when the connection to the database was attempted to be established!');
            exit;
        }
    }

    /**
     * Get the price of all locations and selections, you can specify a different order number than the current or a specific city number or only selected decades
     *
     * @param	integer		$intNo: The order number, if FALSE use the session data
     * @param	integer		$intCity: The city number, if FALSE dont use no city
     * @param	boolean		$bolSelected: Get only selected dates
     * @param	boolean		$bolFormat: Format the price to german standards
     * @return	mixed		The price of the dates
     */
    protected function pi_DBgetPrice($intNo=0, $intCity=0, $bolSelected=FALSE, $bolFormat=FALSE) {
        if (!$intNo || !(int)$intNo) $intNo = $this->session['ordernr'];
        // Construct the SQL statement
        $arrQueryParts = array(
            'SELECT' => 'SUM(termin_preis)',
            'FROM' => 'Login_termine',
            'WHERE' => 'termin_auftrag='.$this->db->fullQuoteStr($intNo, 'Login_termine').($intCity ? ' AND termin_orte='.$this->db->fullQuoteStr($intCity, 'Login_termine') : '').($bolSelected ? " AND termin_selektion='1'" : ''),
        );
        // Do the query
        $mixRes = $this->db->exec_SELECT_queryArray($arrQueryParts);
        $mixValue = @current($this->db->sql_fetch_row($mixRes));
        return $bolFormat ? number_format($mixValue, 2, ',', '.') : $mixValue;
    }

    /**
     * Get the count of all locations and selections, you can specify a different order number than the current or a specific city number or only selected decades
     *
     * @param	integer		$intNo: The order number, if FALSE use the session data
     * @param	integer		$intCity: The city number
     * @param	boolean		$bolSelected: Get only selected dates
     * @return	integer		The number of dates
     */
    protected function pi_DBgetCount($intNo=0, $intCity=0, $bolSelected=FALSE) {
        if (!$intNo || !(int)$intNo) $intNo = $this->session['ordernr'];
        // Construct the SQL statement
        $arrQueryParts = array(
            'SELECT' => 'COUNT(*)',
            'FROM' => 'Login_termine',
            'WHERE' => 'termin_auftrag='.$this->db->fullQuoteStr($intNo, 'Login_termine').($intCity ? ' AND termin_orte='.$this->db->fullQuoteStr($intCity, 'Login_termine') : '').($bolSelected ? " AND termin_selektion='1'" : ''),
        );
        // Do the query
        $mixRes = $this->db->exec_SELECT_queryArray($arrQueryParts);
        return (int)@current($this->db->sql_fetch_row($mixRes));
    }


    /**
     * Get the information (all cols) of the city
     *
     * @param	integer		$intCity: The city number
     * @return	array		The information array
     */
    protected function pi_DBgetCityInfo($intCity) {
        // Construct the SQL statement
        $arrQueryParts = array(
            'SELECT' => '*',
            'FROM' => 'wp_Ort',
            //'WHERE' => 'OrtNr='.$this->db->fullQuoteStr(intval($intCity), 'wp_Ort')." AND Staat='D'",
            'WHERE' => 'OrtNr='.$this->db->fullQuoteStr(intval($intCity), 'wp_Ort'),
        );
        // Do the query
        $mixRes = $this->db->exec_SELECT_queryArray($arrQueryParts);
        return $this->db->sql_fetch_assoc($mixRes);
    }





    /**
     * Get the count of all cities, you can specify a different order number than the current or only selected decades
     *
     * @param	integer		$intNo: The order number, if FALSE use the session data
     * @param	boolean		$bolSelected: The Get only selected dates
     * @return	integer		The number of different cities for the dates
     */
    protected function pi_DBgetCountCities($intNo=0, $bolSelected=FALSE) {
        if (!$intNo || !(int)$intNo) $intNo = $this->session['ordernr'];
        // Construct the SQL statement
        $arrQueryParts = array(
            'SELECT' => 'COUNT(DISTINCT termin_orte)',
            'FROM' => 'Login_termine',
            'WHERE' => 'termin_auftrag='.$this->db->fullQuoteStr($intNo, 'Login_termine').($bolSelected ? " AND termin_selektion='1'" : ''),
        );
        // Do the query
        $mixRes = $this->db->exec_SELECT_queryArray($arrQueryParts);
        return (int)@current($this->db->sql_fetch_row($mixRes));
    }

    /**
     * Get the timestamp of the date and time the order was booked ago
     *
     * @param	integer		$intNo: The order number
     * @return	integer		The time (as an unix timestamp) the order was already booked
     */
    protected function pi_DBgetLastBooking($intNo=0) {
        if (!$intNo || !(int)$intNo) $intNo = $this->session['ordernr'];
        // Construct the SQL statement
        $arrQueryParts = array(
            'SELECT' => 'auftrag_gebucht',
            'FROM' => 'Login_auftrag',
            'WHERE' => 'auftrag_nummer='.$this->db->fullQuoteStr($intNo, 'Login_auftrag'),
        );
        // Do the query
        $mixRes = $this->db->exec_SELECT_queryArray($arrQueryParts);
        return (int)current($this->db->sql_fetch_assoc($mixRes));
    }

    /**
     * Return all order informations from database
     *
     * @param	integer		$intNo: The order number
     * @return	array/bool	The array with all db cols for the selected order, or FALSE if no order was found
     */
    protected function pi_DBgetOrder($intNo=0) {
        if (!$intNo || !(int)$intNo) $intNo = $this->session['ordernr'];
        // Do the query
        $mixRes = $this->db->exec_SELECTquery('*, Login_auftrag.auftrag_nummer ', 'Login_auftrag left join Login_motive on (Login_auftrag.auftrag_nummer = Login_motive.auftrag_nummer) ', 'Login_auftrag.auftrag_nummer='.$this->db->fullQuoteStr($intNo, 'Login_auftrag'));

        $retArr = $this->db->sql_num_rows($mixRes) ? (array)$this->db->sql_fetch_assoc($mixRes) : FALSE;

        if ($retArr) {
            $res = $this->db->exec_SELECTquery('*', 'Login_auftrag_motive', 'auftrag_nummer='.(int)$intNo);
            if ($this->db->sql_num_rows($res)) {
                $motive = $this->db->sql_fetch_assoc($res);
                $retArr = array_merge($retArr, $motive);
            } else {
                $retArr['poster'] = '';
                $retArr['preview'] = '';
                $retArr['poster_selected'] = '';
                $retArr['motiv_accepted'] = '';
            }
        }

        return $retArr;
    }

    /**
     * Return all partner informations from database, if available
     *
     * @param	integer		$intNo: The order number
     * @return	array/bool	The array with all db cols for the selected partner, or FALSE if no partner was found
     */
    protected function pi_DBgetPartner($intNo=0) {
        if (!$intNo || !(int)$intNo) $intNo = $this->session['ordernr'];
        $mixRes = $this->db->exec_SELECTquery('*', 'Login_partner', 'partner_auftrag='.$this->db->fullQuoteStr($intNo, 'Login_partner'));

        $ret = array();
        if ($this->db->sql_num_rows($mixRes)) {
            foreach ($this->db->sql_fetch_assoc($mixRes) as $k => $s) {
                $ret[$k] = utf8_encode($s);
            }
            return $ret;
        }
        return FALSE;
    }




    protected function pi_DBgetSammelauftragMotive($intNo=0) {
        $mixRes = $this->db->exec_SELECTquery('count(motiv_accepted) as motiv_accepted_all', 'Login_auftrag left join Login_auftrag_motive on (Login_auftrag.auftrag_nummer = Login_auftrag_motive.auftrag_nummer)', 'auftrag_sammel='.(int)$intNo);

        $ret = array();
        if ($this->db->sql_num_rows($mixRes)) {
            return (int)current($this->db->sql_fetch_assoc($mixRes));
        }
    }

    protected function pi_DBgetSammelauftragGebucht($intNo=0) {
        $mixRes = $this->db->exec_SELECTquery('count(auftrag_gebucht) as gebucht_all', 'Login_auftrag', 'auftrag_sammel='.(int)$intNo);

        $ret = array();
        if ($this->db->sql_num_rows($mixRes)) {
            return (int)current($this->db->sql_fetch_assoc($mixRes));
        }
    }








    /***************************
     *
     * Session functions
     *
     **************************/


    /**
     * Save the $this->session variables into the database as session
     *
     * @return	void
     */
    protected function pi_SESsave() {
        // Set the session data from $this->session to the session
        $GLOBALS['TSFE']->fe_user->setKey('ses', 'tx_cawlogin_pi[session]', serialize($this->session));
        // store the new session data
        $GLOBALS['TSFE']->fe_user->storeSessionData();
    }

    /**
     * Load the session data from database and store it into $this->session
     *
     * @return	The unserialized session data
     */
    protected function pi_SESload() {
        // Unserialize and store the session data
        $this->session = unserialize($GLOBALS['TSFE']->fe_user->getKey('ses', 'tx_cawlogin_pi[session]'));
    }

















    /***************************
     *
     * Template functions
     *
     **************************/


    /**
     * Replaces the formular marker into the given template
     *
     * @param	string		$strTemplate: The template content
     * @return	string		The content with the substituted language markers
     */
    protected function pi_TPLsubstituteFormularMarker($strTemplate) {
        $arrConf = $this->conf['formular.'];
        // Set default marker
        $arrMarks = array(
            'type' => ($arrConf['type'] || $arrConf['type.']) ? $this->cObj->stdWrap($arrConf['type'], $arrConf['type.']) : $GLOBALS['TSFE']->id,
            'name' => $this->cObj->cleanFormName($this->prefixId),
            'method' => ($arrConf['method'] ? $arrConf['method'] : 'post'),
            'target' => '',
            'enctype' => $GLOBALS['TYPO3_CONF_VARS']['SYS']['form_enctype'],
            'error' => $this->invalid ? $this->cObj->stdWrap($this->pi_getLL('error'), $this->conf['locallang.']['error.']) : '',
            'fieldWrap_b' => $this->prefixId.'[',
            'fieldWrap_e' => ']',
            'fieldSize' => \TYPO3\CMS\Core\Utility\MathUtility::forceIntegerInRange($arrConf['fieldSize'], 1, 80, 20),
            'maxFileSize' => ((int)$arrConf['maxFileSize'] ? (int)$arrConf['maxFileSize'] : $GLOBALS['TYPO3_CONF_VARS']['BE']['maxFileSize']),
            'required' => $this->cObj->stdWrap($arrConf['REQ'], $arrConf['REQ.']),
        );
        // Test, if the page is internal or external
        if (\TYPO3\CMS\Core\Utility\MathUtility::canBeInterpretedAsInteger($arrMarks['type'])) {
            $mixPage = $GLOBALS['TSFE']->sys_page->getPage_noCheck($arrMarks['type']);
            $mixLD = $GLOBALS['TSFE']->tmpl->linkData($mixPage, $arrConf['target'], $arrConf['no_cache'], '', '', $this->cObj->getClosestMPvalueForPage($mixPage['uid']));
            $arrMarks['type'] = $mixLD['totalURL'];
        }
        // A target is given
        if ($arrConf['target'] || $mixLD['target']) {
            $arrMarks['target'] = $arrConf['target'] ? $arrConf['target'] : $mixLD['target'];
            $arrMarks['target'] = $arrMarks['target'] ? ' target="'.$arrMarks['target'].'"' : '';
        }
        // Define the submit button/image data
        $arrSubmit = array(
            'name' => $this->cObj->wrap('submit', $this->prefixId.'[|]'),
            'id' => $arrMarks['name'].'submit',
            'value' => \TYPO3\CMS\Core\Utility\GeneralUtility::deHSCentities(htmlspecialchars($this->pi_getLL('submit'))),
            'params' => ' class="submit"',
            'image' => '',
        );
        // TypoScript configuration for image submit is set
        if (substr($arrConf['image'], 0, 1) == '<' || $arrConf['image.']) {
            if (substr($arrConf['image'], 0, 1) == '<') {
                $objTSparser = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('t3lib_TSparser');
                list(, $arrImgConf) = $objTSparser->getVal(trim(substr($arrConf['image'], 1)), $GLOBALS['TSFE']->tmpl->setup);
                $arrConf['image.'] = $this->cObj->joinTSarrays($arrImgConf, $arrConf['image.']);
            }
            $this->cObj->data[$this->cObj->currentValKey] = $arrSubmit['value'];
            $arrSubmit['image'] = $this->cObj->IMG_RESOURCE($arrConf['image.']);
            $arrSubmit['params'] = $arrConf['image.']['params'] ? ' '.$arrConf['image.']['params'] : '';
            $arrSubmit['params'] .= $this->cObj->getAltParam($arrConf['image.'], FALSE);
        }
        if ($arrSubmit['image']) {
            $arrMarks['submit'] = sprintf('<input type="image" name="%s" id="%s" src="%s"%s />', $arrSubmit['name'], $arrSubmit['id'], $arrSubmit['image'], $arrSubmit['params']);
        } else {
            $arrMarks['submit'] = sprintf('<input type="submit" name="%s" id="%s" value="%s"%s />', $arrSubmit['name'], $arrSubmit['id'], $arrSubmit['value'], $arrSubmit['params']);
        }
        // Substitute the subpart into the given template
        return (string)$this->cObj->substituteMarkerArray($strTemplate, $arrMarks, '###FORM_|###');
    }

    /**
     * Replaces the data content into the given template
     *
     * @param	string		$strTemplate: The template content
     * @param	array		$arrData: The array with the data to replace into the template
     * @param	tslib_cObj	$objCObject: The instance of tslib_cObj to parse the data through
     * @return	string		The content with the substituted language markers
     */
    protected function pi_TPLsubstituteDataMarker($strTemplate, array $arrData, $objCObj=FALSE) {
        if (!is_object($objCObj)) $objCObj = &$this->cObj;
        $arrMarks = array();
        // Replace all available language marker it
        if (count($arrData)) {
            foreach ($arrData as $strKey => $mixValue) {
                //while (list($theKey, $theValue) = each($data)) {
                $arrMarks[$strKey] = $objCObj->stdWrap($mixValue, $this->conf['data.'][$strKey.'.']);
            }
        }
        // Substitute the subpart into the given template
        return (string)$objCObj->substituteMarkerArray($strTemplate, $arrMarks, '###DATA_|###');
    }

    /**
     * Replaces the language content into the given template
     *
     * @param	string		$strTemplate: The template content
     * @param	tslib_cObj	$objCObject: The instance of tslib_cObj to parse the data through
     * @return	string		The content with the substituted language markers
     */
    protected function pi_TPLsubstituteLanguageMarker($strTemplate='', $objCObj=FALSE) {
        if (!is_object($objCObj)) $objCObj = &$this->cObj;
        $arrMarks = array();
        // Get all locallang arrays
        $arrLL = ($this->LLkey && is_array($this->LOCAL_LANG[$this->LLkey])) ? $this->LOCAL_LANG[$this->LLkey] : array();
        $arrLLalt = ($this->altLLkey && is_array($this->LOCAL_LANG[$this->altLLkey])) ? $this->LOCAL_LANG[$this->altLLkey] : array();
        $arrLLdef = is_array($this->LOCAL_LANG['default']) ? $this->LOCAL_LANG['default'] : array();
        // Merge all locallang arrays
        //doemedia begin
        $arrLOCAL_LANG = array();
        if($arrLLdef) {
            \TYPO3\CMS\Core\Utility\ArrayUtility::mergeRecursiveWithOverrule($arrLOCAL_LANG, $arrLLdef);
        }
        if($arrLL) {
            \TYPO3\CMS\Core\Utility\ArrayUtility::mergeRecursiveWithOverrule($arrLOCAL_LANG, $arrLL);
        }
        if($arrLLalt) {
            \TYPO3\CMS\Core\Utility\ArrayUtility::mergeRecursiveWithOverrule($arrLOCAL_LANG, $arrLLalt);
        }
        //doemedia end

        // Replace all available language marker it
        if (is_array($arrLOCAL_LANG)) {
//            while (list($strKey) = each($arrLOCAL_LANG)) {
            foreach ($arrLOCAL_LANG as $strKey => $value) {

                $arrMarks['###LL_'.$strKey.'###'] = $objCObj->stdWrap($this->pi_getLL($strKey), $this->conf['locallang.'][$strKey.'.']);
            }
        }
        // Substitute the subpart into the given template
        return (string)$objCObj->substituteMarkerArrayCached($strTemplate, $arrMarks);
    }

    /**
     * Publicate the javascript code into the output content. Creates an temporary file if extension is not USER_INT, otherwise
     *
     * @param	string		$content: The javascript content
     * @return	void
     */
    protected function pi_TPLpublicateJavascript($strContent) {
        // Extension is not cached, print the javascript into the html
//        if ($this->pi_USER_INT_obj) {
//            $strContent = \TYPO3\CMS\Core\Utility\GeneralUtility::wrapJS($strContent);
//            // Extension is cached, save the javascript into a temporary file
//        } else {
//            $strContent = TSpagegen::inline2TempFile($strContent, 'js');
//        }
        // Store the javascript to the typo3 headers
//        $GLOBALS['TSFE']->additionalHeaderData[$this->prefixId.'_JS'] = $strContent;



        $this->pageRenderer->addJsFooterFile(
            \TYPO3\CMS\Frontend\Page\PageGenerator::inline2TempFile($strContent, 'js'),
            'text/javascript',
            $GLOBALS['TSFE']->config['config']['compressJs']
        );
    }

















    /***************************
     *
     * Data validation
     *
     **************************/


    /**
     * Check the inserted data for validation
     *
     * @param	array		$data: The array to check for valid data
     * @return	boolean		TRUE if the data are valid, else FALSE
     */
    protected function pi_DATAvalidate(array $arrData)	{
        // Clear the variable for each process
        $this->invalid = '';
        $arrRequired = \TYPO3\CMS\Core\Utility\GeneralUtility::trimExplode(',', $this->requiredData);
        reset($arrRequired);
        // Check the given data with the definitions
        while (list(, $strValue) = each($arrRequired)) {
            // Split the fieldname and the regular expressions
            $arrValue = \TYPO3\CMS\Core\Utility\GeneralUtility::trimExplode(':', $strValue.':');
            switch (strtoupper($arrValue[1])) {
                // The field had to be a valid email address
                case 'EMAIL':
                    if (!\TYPO3\CMS\Core\Utility\GeneralUtility::validEmail($arrData[$arrValue[0]])) {
                        $this->invalid .= $arrValue[0].',';
                    }
                    break;
                // The field had to pass a regular expression
                case 'EREG':
                    if (!preg_match($arrValue[2], $arrData[$arrValue[0]])) {
                        $this->invalid .= $arrValue[0].',';
                    }
                    break;
                // The field had to fail a regular expression
                case '!EREG':
                    if (preg_match($arrValue[2], $arrData[$arrValue[0]])) {
                        $this->invalid .= $arrValue[0].',';
                    }
                    break;
                // The field must not be empty
                default:
                    if ($arrData[$arrValue[0]] === '' || !isset($arrData[$arrValue[0]])) {
                        $this->invalid .= $arrValue[0].',';
                    }
                    break;
            }
        }
        return $this->invalid ? FALSE : TRUE;
    }

















    /***************************
     *
     * Menu functions
     *
     **************************/


    /**
     * Replace the menu item "Plakatmotiv bearbeiten", if no interface is set for this order number
     *
     * @param	array		$arrMenu: The array with the current menu
     * @param	array		$arrConf: The menu configuration
     * @return	array		The new menu with or without entry "Plakatmotiv bearbeiten"
     */
    public function mainMenuShowPosterMotiv(array $arrMenu, array $arrConf) {
        $this->init();
        $arrInfo = $this->pi_DBgetOrder();
        $arrNewMenu = array();
        foreach ($arrMenu as $strKey => $mixValue) {
            // If the order is editable and the current menu item is the page "Buchung abschliessen" then add it to the new menu array
            if ($mixValue['uid'] == $arrConf['auftrag_selection'] && !$arrInfo['auftrag_selection']) {
                continue;
                // If the order interface is 'staudigl' and the current menu item is the page "Plakatmotiv bearbeiten" then add it to the new menu array
            } elseif ($mixValue['uid'] == $arrConf['auftrag_schnittstelle'] && $arrInfo['auftrag_schnittstelle'] != 'staudigl') {
                continue;
                // If the order interface is 'staudigl' and the current menu item is the page "Plakatmotiv bearbeiten" then add it to the new menu array
            } elseif ($mixValue['uid'] == $arrConf['auftrag_motif'] && empty($arrInfo['auftrag_motivordner'])) {
                continue;
            }
            // Return this menu item
            $arrNewMenu[] = $mixValue;
        }
        return (array)$arrNewMenu;
    }

    /**
     * Create a third menu level with all cities listed in this order
     *
     * @param	array		$arrMenu: The array with the current menu
     * @param	array		$arrConf: The menu configuration
     * @return	array		The new third menu with all cities
     */
    public function extendMenu(array $arrMenu, array $arrConf) {
        $this->init();
        $piVars = \TYPO3\CMS\Core\Utility\GeneralUtility::GPvar('tx_cawlogin_pi3', TRUE);
        $arrNewMenu = array();
        // Create SQL statement
        $arrQueryParts = array(
            'SELECT' => '*',
            //'FROM' => "Login_termine LEFT JOIN(wp_Ort) ON (wp_Ort.Staat='D' AND Login_termine.termin_orte=wp_Ort.OrtNr)",
            'FROM' => "Login_termine LEFT JOIN(wp_Ort) ON (Login_termine.termin_orte=wp_Ort.OrtNr)",
            'WHERE' => "termin_auftrag='".$this->session['ordernr']."'",# AND termin_selektion='1'",
            'GROUPBY' => 'termin_orte',
            'ORDERBY' => 'Ortname ASC',
        );
        // Do the SQL query
        $mixRes = $this->db->exec_SELECT_queryArray($arrQueryParts);
        // create the new menu items for every location
        while ($arrRow = $this->db->sql_fetch_assoc($mixRes)) {
            // Create new dummy entry
            $arrNewMenu[] = array(
                'uid' => '-1', //$arrConf['uid'].'&tx_cawlogin_pi3[ort]='.$arrRow['termin_orte'],  //change the page including new parameters
                'pid' => $arrConf['pid'],
                'tstamp' => time(),
                'deleted' => 0,
                'perms_userid' => $arrConf['cruser_id'],
                'perms_groupid' => 1,
                'perms_user' => 31,
                'perms_group' => 31,
                'perms_everybody' => 0,
                'crdate' => time(),
                'cruser_id' => $arrConf['cruser_id'],
                'title' => $GLOBALS['TSFE']->csConv($arrRow['Ortname'], 'iso-8859-1'),
                'doktype' => 1,
                'hidden' => 0,
                'starttime' => 0,
                'endtime' => 0,
                'no_cache' => 0,
                'target' => '_parent', // sets the link target e.g. _blank
                '_OVERRIDE_HREF' => $this->cObj->getTypoLink_URL($arrConf['uid'], array('tx_cawlogin_pi3' => array('ort' => $arrRow['termin_orte']))),
                'SYS_LASTCHANGED' => time(),
                'ITEM_STATE' => ($piVars['ort'] == $arrRow['termin_orte']) ? 'ACT' : 'NO',
            );
        }
        return (array)$arrNewMenu;
    }








    protected function getMotifAdd($strMessage, $style='mail', $s = "%s : %s \n") {
        $showmotivadd = $this->cObj->getSubpart($strMessage, '###SHOWMOTIVADD###');
        if (isset($this->session['includeMail'])) {

            foreach($this->session['includeMail'] as $key => $value) {
                $showmotivadd .= sprintf($s,
                    ($this->pi_getLL($style.'_'.$key) ?  $this->pi_getLL($style.'_'.$key) : $key ),
                    ($this->pi_getLL($style.'_'.$key. '_data_'.$value) ? $this->pi_getLL($style.'_'.$key. '_data_'.$value) : $value)
                );

            }
        } else {
            $showmotivadd = '';
        }
        return $showmotivadd;
    }








    /***************************
     *
     * Excel functions
     *
     **************************/

    /**
     * Creates the xml
     *
     * @param	integer		$intNo: The order number
     * @param	string		$strFile: The filename for the saved file
     * @return	string		Returns the full file path, or the file content
     */
    protected function pi_XMLcreateMotif($intNo=0, $strFile='') {
        if (!$intNo || !(int)$intNo) $intNo = $this->session['ordernr'];
        // Get the template
        $strTemplate = $this->cObj->fileResource($this->cObj->stdWrap($this->conf['templateXML'], $this->conf['templateXML.']));
        $templateLocations = $this->cObj->getSubpart($strTemplate, '###LOCATIONS###');
        $templateDecades = $this->cObj->getSubpart($templateLocations, '###SELECTIONS###');

        // Get the informations from database
        $arrData = array_merge($this->pi_DBgetPartner($intNo), $this->pi_DBgetOrder($intNo));

        $showmotiv = !empty($arrData['poster']);
        if ($showmotiv) {
            if (!empty($arrData['poster']) && !preg_match('/^https?:\/\//i', $arrData['poster']))
                $arrData['poster'] = \TYPO3\CMS\Core\Utility\GeneralUtility::locationHeaderUrl($arrData['poster']);
            $arrData['poster'] = str_replace('https://', 'http://', $arrData['poster']);
            if (!empty($arrData['auftrag_mithintergrund'])) {
                $arrData['poster'] .= '&no_background=1';
            }
        } elseif (empty($arrData['poster'])) {
            $arrData['preview'] = '';
            $arrData['poster'] = '';
        }
        $arrData['poster'] = urlencode($arrData['poster']);

        $arrQueryParts = array(
            'SELECT' => '*',
            'FROM' => "Login_termine LEFT JOIN (wp_Ort) ON (termin_orte=OrtNr) LEFT JOIN (Login_standorte) ON (termin_standorte=standort_nummer AND termin_stelle=standort_stelle AND termin_paechter=standort_paechter)",
            'WHERE' => 'termin_auftrag='.$this->db->fullQuoteStr($intNo, 'Login_termin') . " AND termin_selektion='1'",
            'ORDERBY' => 'Ortname,standort_name,termin_dekade',
        );
        $mixRes = $this->db->exec_SELECT_queryArray($arrQueryParts);
        $subpartsa = '';
        while ($row = $this->db->sql_fetch_assoc($mixRes)) {
            foreach ($row as $theKey => $theValue) $row[$theKey] = htmlspecialchars($GLOBALS['TSFE']->csConv($row[$theKey], 'iso-8859-1'));
            //foreach ($row as $theKey => $theValue) $row[$theKey] = htmlspecialchars($row[$theKey], 'iso-8859-1');

            $subpartsa .= $this->cObj->substituteMarkerArray($templateLocations, $row, '###|###', true);
        }
        $strTemplate = $this->cObj->substituteSubpart($strTemplate, '###LOCATIONS###', $subpartsa);
        $strTemplate = $this->cObj->substituteSubpart($strTemplate, '###SHOWMOTIVADD###', $this->getMotifAdd($strTemplate, 'xml', ' %s = "%s" '));

        $strContent = $this->pi_TPLsubstituteDataMarker($strTemplate, $arrData);
        $strContent = $this->pi_TPLsubstituteLanguageMarker($strContent);
        // Save the content to a file
        if ($strFile) {
            \TYPO3\CMS\Core\Utility\GeneralUtility::writeFile($strFile, $strContent);
            return (string)$strFile;
        }
        // Return the content
        return (string)$strContent;
    }

    /**
     * Creates the excel file with partner informations
     *
     * @param	integer		$intNo: The order number
     * @param	string		$strFile: The filename for the saved file
     * @return	string		Returns the full file path, or the file content
     */
    protected function pi_XLScreatePartner($intNo=0, $strFile='') {
        if (!$intNo || !(int)$intNo) $intNo = $this->session['ordernr'];
        // Get the template
        $strFileResource = $this->cObj->fileResource($this->cObj->stdWrap($this->conf['templateExcel'], $this->conf['templateExcel.']));
        $strTemplate = $this->cObj->getSubpart($strFileResource, '###FRAME###');
        $strTemplate = $this->cObj->substituteSubpart($strTemplate, '###CONTENT###', $this->cObj->getSubpart($strFileResource, '###PARTNER###'));
        // Get the informations from database
        $arrData = \TYPO3\CMS\Core\Utility\ArrayUtility::mergeRecursiveWithOverrule($this->pi_DBgetPartner($intNo), $this->pi_DBgetOrder($intNo));
        $arrData['partner_alterauftrag'] = ($arrData['partner_alterauftrag'] == -1) ?  '###LL_xlsUnknown###' : ($arrData['partner_alterauftrag'] ? $arrData['partner_alterauftrag'] : '');
        //foreach($arrData as $strKey => $strValue) if (substr($strKey, 0, 8) == 'partner_') $arrData[$strKey] = utf8_decode($strValue);
        $strContent = $this->pi_TPLsubstituteDataMarker($strTemplate, $arrData);
        $strContent = $this->pi_TPLsubstituteLanguageMarker($strContent);
        // Save the content to a file
        if ($strFile) {
            \TYPO3\CMS\Core\Utility\GeneralUtility::writeFile($strFile, $strContent);
            return (string)$strFile;
        }
        // Return the content
        return (string)$strContent;
    }

    /**
     * Creates the excel file with location informations
     *
     * @param	integer		$intNo: The order number
     * @param	string		$strWhich: '' or 'Gebucht' or 'Entfernt'
     * @param	string		$strFile: The filename for the saved file
     * @return	string		Returns the full file path, or the file content
     */
    protected function pi_XLScreateLocations($intNo=0, $strWhich='', $strFile='') {
        if (!$intNo || !(int)$intNo) $intNo = $this->session['ordernr'];
        // Get the template
        $strFileResource = $this->cObj->fileResource($this->cObj->stdWrap($this->conf['templateExcel'], $this->conf['templateExcel.']));
        $strTemplate = $this->cObj->getSubpart($strFileResource, '###FRAME###');
        $strTemplate = $this->cObj->substituteSubpart($strTemplate, '###CONTENT###', $this->cObj->getSubpart($strFileResource, '###LOCATIONS###'));
        // Define some variables
        $strContent = '';
        $strContentRepetition = '';
        $strCity = '';
        $intLocationTotal = 0;
        $floatLocationPrice = 0.0;
        $intTotal = 0;
        $floatTotal = 0.0;
        // Get informations of the order
        $arrOrder = $this->pi_DBgetOrder($intNo);
        // Create the SQL statement
        $arrQueryParts = array(
            'SELECT' => '*',
            //'FROM' => "Login_termine LEFT JOIN (wp_Ort) ON (Staat='D' AND termin_orte=OrtNr) LEFT JOIN (Login_standorte) ON (termin_standorte=standort_nummer AND termin_stelle=standort_stelle AND termin_paechter=standort_paechter)",
            'FROM' => "Login_termine LEFT JOIN (wp_Ort) ON (termin_orte=OrtNr) LEFT JOIN (Login_standorte) ON (termin_standorte=standort_nummer AND termin_stelle=standort_stelle AND termin_paechter=standort_paechter)",
            'WHERE' => 'termin_auftrag='.$this->db->fullQuoteStr($intNo, 'Login_termin'),
            'ORDERBY' => 'Ortname,standort_name,termin_dekade',
        );
        // Limit the where statement by the $strWhich variable
        if ($strWhich == 'Gebucht') {
            $arrQueryParts['WHERE'] .= " AND termin_selektion='1'";
        } elseif ($strWhich == 'Entfernt') {
            $arrQueryParts['WHERE'] .= " AND termin_selektion='0'";
        }
        // Do the sql
        $mixRes = $this->db->exec_SELECT_queryArray($arrQueryParts);
        while ($arrRow = $this->db->sql_fetch_assoc($mixRes)) {
            // This is a new city
            if ($arrRow['termin_orte'] != $strCity) {
                if ($strCity) {
                    $strContentRepetition .= $this->getExcelLocationSumsLine($intLocationTotal, $floatLocationPrice, $arrOrder['auftrag_preis']);
                }
                // Append empty line
                $strContentRepetition .= $this->getExcelEmptyLine($arrOrder['auftrag_preis']);
                // Add the city line
                $strContentRepetition .= $this->getExcelNewCityLine($arrRow['PLZ'], $arrRow['OrtNr'], $arrRow['Ortname'], $arrOrder['auftrag_preis']);
                $strCity = $arrRow['termin_orte'];
                $intLocationTotal = 0;
                $floatLocationPrice = 0.0;
            }
            // Append this location
            $strContentRepetition .= $this->getExcelLocationLine($arrRow['termin_selektion'], $strWhich, $arrRow['termin_standorte'], $arrRow['termin_paechter'], $arrRow['termin_stelle'], $arrRow['standort_name'], $arrRow['standort_h_anschlag'], $$arrRow['standort_u_anschlag'], $arrRow['termin_dekade'], $arrRow['termin_preis'], $arrOrder['auftrag_preis']);
            if ($arrRow['termin_selektion'] || $strWhich == 'Entfernt') {
                // Increase the location sum/count
                $intLocationTotal++;
                // Increase the location price by the current price
                $floatLocationPrice += $arrRow['termin_preis'];
                // Increase the total sum/count
                $intTotal++;
                // Increase the total price by the current price
                $floatTotal += $arrRow['termin_preis'];
            }
        }
        // Add a sum line
        $strContentRepetition .= $this->getExcelLocationSumsLine($intLocationTotal, $floatLocationPrice, $arrOrder['auftrag_preis']);
        $strContent = $this->cObj->substituteSubpart($strTemplate, '###REPETITION###', $strContentRepetition);
        // Pass through header and footer maker
        $strContent = $this->pi_XLSpassHeader($strContent, $arrOrder['auftrag_preis'], $strWhich, $intNo);
        $strContent = $this->pi_XLSpassFooter($strContent, $arrOrder['auftrag_preis'], $intTotal, $floatTotal);
        // Save the content to a file
        if ($strFile) {
            \TYPO3\CMS\Core\Utility\GeneralUtility::writeFile($strFile, $strContent);
            return (string)$strFile;
        }
        // Return the content
        return (string)$strContent;
    }

    /**
     * Creates the excel file with the interface informations
     *
     * @param	integer		$intNo: The order number
     * @param	string		$strFile: The filename for the saved file
     * @return	string		The full file path, or the file content
     */
    protected function pi_XLScreateInterface($intNo=0, $strFile='') {
        if (!$intNo || !(int)$intNo) $intNo = $this->session['ordernr'];
        // Get the template
        $strFileResource = $this->cObj->fileResource($this->cObj->stdWrap($this->conf['templateExcel'], $this->conf['templateExcel.']));
        $strTemplate = $this->cObj->getSubpart($strFileResource, '###FRAME###');
        $strTemplate = $this->cObj->substituteSubpart($strTemplate, '###CONTENT###', $this->cObj->getSubpart($strFileResource, '###INTERFACE###'));
        $strTemplateRepetition = $this->cObj->getSubpart($strTemplate, '###REPETITION###');
        // Define some variables
        $strContent = '';
        $strContentRepetition = '';
        $floatTotal = 0.0;
        // Create the SQL statement
        $arrQueryParts = array(
            'SELECT' => 'standort_versandnr,termin_dekade,termin_paechter,COUNT(*) AS standort_summe',
            'FROM' => 'Login_termine LEFT JOIN (Login_standorte) ON (termin_standorte=standort_nummer AND termin_stelle=standort_stelle AND termin_paechter=standort_paechter)',
            'WHERE' => 'termin_auftrag='.$this->db->fullQuoteStr($intNo, 'Login_termine').' AND termin_selektion=1',
            'GROUPBY' => 'termin_dekade,standort_versandnr',
        );
        // Do the SQL query
        $mixRes = $this->db->exec_SELECT_queryArray($arrQueryParts);
        while ($arrRow = $this->db->sql_fetch_assoc($mixRes)) {
            $strContentRepetition .= $this->pi_TPLsubstituteDataMarker($strTemplateRepetition, $arrRow);
            $floatTotal += $arrRow['standort_summe'];
        }
        // Global markers
        $arrData = array(
            'total' => $floatTotal,
            'order' => $intNo,
        );
        // Create the content
        $strContent = $this->cObj->substituteSubpart($strTemplate, '###REPETITION###', $strContentRepetition);
        $strContent = $this->pi_TPLsubstituteDataMarker($strContent, $arrData);
        $strContent = $this->pi_TPLsubstituteLanguageMarker($strContent);
        // Save the content to a file
        if ($strFile) {
            \TYPO3\CMS\Core\Utility\GeneralUtility::writeFile($strFile, $strContent);
            return (string)$strFile;
        }
        // Return the content
        return (string)$strContent;
    }

    /**
     * The getExcelNewCityLine method of the PlugIn
     *
     * @param	string		$strZip: The zip
     * @param	string		$strCity: The city number
     * @param 	string		$strName: The city name
     * @param	boolean		$bolShowPrice: Show the price column
     * @return	string		The excel line
     */
    protected function getExcelNewCityLine($strZip, $strCity, $strName, $bolShowPrice) {
        $strContent = '<tr>
					<td class="xl20" x:num nowrap>'.$strZip.'</td>
					<td class="xl21" x:num nowrap>'.$strCity.'</td>
					<td class="xl22">'.$strName.'</td>
					<td class="xl22"></td>
					<td class="xl22"></td>
					<td class="xl22"></td>
					<td class="xl22"></td>
					<td class="xl22"></td>
					<td class="xl22"></td>
					';
        $strContent .= ($bolShowPrice) ? '<td class="xl22"></td>' : '';
        $strContent .= '</tr>';
        return (string)$strContent;
    }

    /**
     * The getExcelLocationLine method of the PlugIn
     *
     * @param	boolean		$bolSelect: Is this one selected
     * @param	string		$strWhich: '' / 'Gebucht' / 'Entfernt
     * @param 	integer		$intLocation: The location number
     * @param	integer		$intTenant: The tenant number
     * @param	integer		$intPosition: The position
     * @param	string		$strName: The location name
     * @param	string		$strHS: The hs of the location
     * @param	string		$strUS: The us of the location
     * @param	integer		$intDecate: The decade of the location
     * @param	float		$floatPrice: The price of the location
     * @param	boolean		$bolShowPrice: Show the price column
     * @return	string		The excel line
     */
    protected function getExcelLocationLine($bolSelect, $strWhich, $intLocation, $intTenant, $intPosition, $strName, $strHS, $strUS, $intDecate, $floatPrice, $bolShowPrice) {
        $strContent = '<tr>
						<td></td>
					';
        $strContent .= ($bolSelect) ? '<td class="xl28" nowrap><b>p</b></td>' : '<td class="xl28" nowrap></td>';
        $strContent .= '<td class="xl26" x:num nowrap>'.$intLocation.'</td>
				<td class="xl26" x:num nowrap>'.$intTenant.'</td>
				<td class="xl26" x:num nowrap>'.$intPosition.'</td>
				<td nowrap>'.$strName.'</td>
				<td nowrap>'.$strHS.'</td>
				<td nowrap>'.$strUS.'</td>
				<td class="xl26" x:num nowrap>'.$intDecate.'</td>';
        if ($bolShowPrice) {
            if ($bolSelect || $strWhich == 'Entfernt' ) {
                $strContent .= '<td class="xl27" x:num="'.$floatPrice.'" nowrap>
					<span style="mso-spacerun:yes"> </span>
					'.number_format($floatPrice ,2,',','.').' €
				</td>';
            } else {
                $strContent .= '<td class="xl27" x:num="0" nowrap>
						<span style="mso-spacerun:yes"> </span>-
						<span style="mso-spacerun:yes">   </span>€ 
					</td>';
            }
        }
        $strContent .= '</tr>';
        return (string)$strContent;
    }

    /**
     * The getExcelEmptyLine method of the PlugIn
     *
     * @param	boolean		$bolShowPrice: Show the price column
     * @return	string		The excel line
     */
    protected function getExcelEmptyLine($bolShowPrice) {
        $strContent = '<tr>
						<td></td>
						<td></td>
						<td></td>
						<td></td>
						<td></td>
						<td></td>
						<td></td>
						<td></td>
						<td></td>';
        $strContent .= ($bolShowPrice) ? '<td></td>' : '';
        $strContent .= '</tr>';
        return (string)$strContent;
    }

    /**
     * The getExcelLocationSumsLine method of the PlugIn
     *
     * @param	integer		$intLocations: The count of the locations
     * @param	float		$floatPrice: The price of the locations
     * @param	boolean		$bolShowPrice: Show the price column
     * @return	string		The excel line
     */
    protected function getExcelLocationSumsLine($intLocations, $floatPrice, $bolShowPrice) {
        $strContent = '<tr>
						<td class="xl23"></td>
						<td class="xl23"></td>
						<td class="xl23"></td>
						<td class="xl23"></td>
						<td class="xl23"></td>
						<td class="xl23"></td>
						<td class="xl23"></td>
						<td class="xl23"></td>
						<td class="xl23" x:num nowrap>'.$intLocations.'</td>';
        if ($bolShowPrice) {
            $strContent .= '<td class="xl25" x:num="'.$floatPrice.'" nowrap>
				<span style="mso-spacerun:yes"> </span>'.number_format($floatPrice ,2,',','.').' €
			</td>';
        }
        $strContent .= '</tr>';
        $strContent .= $this->getExcelEmptyLine($bolShowPrice);
        return (string)$strContent;
    }

    /**
     * Creates the header rows for the excel file "locations"
     *
     * @param	string		$strTemplate: The content to pass
     * @param	boolean		$bolShowPrice: Show the price column
     * @param	string		$strWhich: '' / 'Gebucht' / 'Entfernt'
     * @param	integer		$intNo: The order number
     * @return	string		The excel content
     */
    protected function pi_XLSpassHeader($strTemplate, $bolShowPrice, $strWhich, $intNo) {
        $strContent = $this->cObj->getSubpart($strTemplate, '###HEADER###');
        // Create the array with the markers to replace
        $arrData = array(
            'colspan' => $bolShowPrice ? 10 : 9,
            'no' => $intNo,
            'title' => ($strWhich != 'Gebucht' && $strWhich != 'Entfernt') ? 'All' : $strWhich,
        );
        $strContent = $this->pi_TPLsubstituteDataMarker($strContent, $arrData);
        $strContent = $this->pi_TPLsubstituteLanguageMarker($strContent);
        // Display or do not display prices
        $strContentPrice = ($bolShowPrice) ? $this->cObj->getSubpart($strContent, '###SHOWPRICE###') : '';
        $strContent = $this->cObj->substituteSubpart($strContent, '###SHOWPRICE###', $strContentPrice);
        return (string)$this->cObj->substituteSubpart($strTemplate, '###HEADER###', $strContent);
    }

    /**
     * Creates the footer rows for the excel file "locations"
     *
     * @param	string		$strTemplate: The content to pass
     * @param	boolean		$showprice: Show the price column
     * @param	integer		$intTotal: The total count of the city's locations
     * @param 	float		$floatPrice: The total price of the city's locations
     * @return	string		The excel content
     */
    protected function pi_XLSpassFooter($strTemplate, $bolShowPrice, $intTotal, $floatPrice) {
        $strContent = $this->cObj->getSubpart($strTemplate, '###FOOTER###');
        // Create the array with the markers to replace
        $arrData = array(
            'total' => $intTotal,
            'price' => $floatPrice,
            'priceFormat' => number_format($floatPrice, 2, ',', '.'),
        );
        $strContent = $this->pi_TPLsubstituteDataMarker($strContent, $arrData);
        $strContent = $this->pi_TPLsubstituteLanguageMarker($strContent);
        // Display or do not display prices
        $strContentPrice = ($bolShowPrice) ? $this->cObj->getSubpart($strContent, '###SHOWPRICE###') : '';
        $strContent = $this->cObj->substituteSubpart($strContent, '###SHOWPRICE###', $strContentPrice);
        return (string)$this->cObj->substituteSubpart($strTemplate, '###FOOTER###', $strContent);
    }

















    /***************************
     *
     * Localization, locallang functions
     *
     **************************/


    /**
     * Returns the localized label of the LOCAL_LANG key, $key
     *
     * @param	string		$strKey: The key from the LOCAL_LANG array for which to return the value.
     * @return	string		The value from LOCAL_LANG.
     */
    protected function pi_LLget($strKey)	{
        if (isset($this->LOCAL_LANG[$this->LLkey][$strKey]))	{
            return $this->LOCAL_LANG[$this->LLkey][$strKey];
        } elseif ($this->altLLkey && isset($this->LOCAL_LANG[$this->altLLkey][$strKey]))	{
            return $this->LOCAL_LANG_charset[$this->altLLkey][$strKey];
        } elseif (isset($this->LOCAL_LANG['default'][$strKey]))	{
            return $this->LOCAL_LANG['default'][$strKey];
        }

        return '';
    }

    /**
     * Set new localized label $newVal of the LOCAL_LANG key, $key
     *
     * @param	string		The key from the LOCAL_LANG array for which to return the value.
     * @param	string		Alternative string to return IF no value is found set for the key, neither for the local language nor the default.
     * @return	void
     */
    protected function pi_LLset($strKey, $strNewVal)	{
        if (isset($this->LOCAL_LANG[$this->LLkey][$strKey]))	{
            $this->LOCAL_LANG[$this->LLkey][$strKey] = $strNewVal;
        } elseif ($this->altLLkey && isset($this->LOCAL_LANG[$this->altLLkey][$strKey]))	{
            $this->LOCAL_LANG[$this->altLLkey][$strKey] = $strNewVal;
        } elseif (isset($this->LOCAL_LANG['default'][$strKey]))	{
            $this->LOCAL_LANG['default'][$strKey] = $strNewVal;
        }
    }
}


if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/caw_login/pi/class.tx_cawlogin_pi.php'])	{
    include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/caw_login/pi/class.tx_cawlogin_pi.php']);
}
