<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2008 Jan Roemich <jroemich@dpi-one.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * ORTS�BERSICHT
 *
 *
 *
 *   71: class tx_cawlogin_pi2 extends tx_cawlogin_pi
 *
 *              SECTION: Main function
 *  113:     function init()
 *  139:     function main($content, $conf)
 *
 * TOTAL FUNCTIONS: 1
 *
 */























require_once(\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath('cawlogin').'plugins/pi/class.tx_cawlogin_pi.php');


/**
 * Plugin 'Customerlogin [Location overview]' for the 'cawlogin' extension.
 *
 * @author	Jan Roemich <jroemich@dpi-one.de>
 * @package	TYPO3
 * @subpackage	tx_cawlogin
 */
class tx_cawlogin_pi2 extends tx_cawlogin_pi {
    public $prefixId      = 'tx_cawlogin_pi2';		// Same as class name
    public $scriptRelPath = 'plugins/pi2/class.tx_cawlogin_pi2.php';	// Path to this script relative to the extension dir.
    public $extKey        = 'cawlogin';	// The extension key.





    /**
     * The main method of the PlugIn
     *
     * @param	string		$strContent: The PlugIn content
     * @param	array		$arrConf: The PlugIn configuration
     * @return	string		The content that is displayed on the website
     */
    public function main($strContent, array $arrConf)	{
        $this->conf = $arrConf;
        $this->pi_setPiVarDefaults();
        $this->pi_loadLL();
        $this->pi_USER_INT_obj = 1;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!
        $this->pi_initPIflexForm();

        // Main initialization
        parent::init();

        /*
        $arrOrder = $this->pi_DBgetOrder();
        if (empty($arrOrder['auftrag_motivordner']))  {
            $arrConf['locallang.']['next.']['typolink.']['parameter'] = 93;
            print_r($arrConf['locallang.']);
        }*/

        $strContent = $this->showCities();
        $strContent = $this->pi_TPLsubstituteLanguageMarker($strContent);

        return $strContent;
    }

    /**
     * The showCities method of the PlugIn
     *
     * @return	string		The content that is displayed on the website
     */
    private function showCities() {
        // Get the template
        $strFileResource = $this->cObj->stdWrap($this->conf['templateFile'], $this->conf['templateFile.']);
        $strTemplate = $this->cObj->fileResource($strFileResource);
        $strTemplate = $this->cObj->getSubpart($strTemplate, '###'.$this->prefixId.'###');
        $strTemplateLocation = $this->cObj->getSubpart($strTemplate, '###LOCATIONS###');

        // Define variables
        $bolHighlight = TRUE;
        $strContent = '';

        // Show or hide the map
        $arrQueryParts = array(
            'SELECT' => '*',
            'FROM' => 'Login_termine LEFT JOIN wp_Sto ON(termin_standorte=StoNr AND termin_stelle=StoV AND termin_paechter=Paechter AND termin_orte=OrtNr AND YEAR(termin_beginn)=GJ)',
            'WHERE' => "termin_auftrag='".$this->session['ordernr']."' AND UTMLA NOT IN('0', '0.0', '') AND UTMBA NOT IN('0', '0.0', '')",
            'GROUPBY' => '',
            'ORDERBY' => '',
            'LIMIT' => '1',
        );
        $mixRes0 = $this->db->exec_SELECT_queryArray($arrQueryParts);
        $hideMap = !$this->db->sql_num_rows($mixRes0);
        $this->db->sql_free_result($mixRes0);

        // Create the SQL statement
        // doemedia: Nicht kompatibel mit sql_mode='ONLY_FULL_GROUP_BY'
        $arrQueryParts = array(
            'SELECT' => '*, COUNT(*) AS termin_summe, SUM(termin_selektion) AS termin_checked, SUM(termin_preis) AS termin_gesamtpreis',
//			'FROM' => "Login_termine LEFT JOIN(wp_Ort) ON (Staat='D' AND termin_orte=OrtNr) LEFT JOIN (Login_bundesland) ON (FLOOR(termin_orte / 1000000)=bundesland_nummer)",
            'FROM' => "Login_termine LEFT JOIN(wp_Ort) ON (termin_orte=OrtNr) LEFT JOIN (Login_bundesland) ON (FLOOR(termin_orte / 1000000)=bundesland_nummer)",
            'WHERE' => "termin_auftrag='".$this->session['ordernr']."'",
            'GROUPBY' => 'termin_orte',
            'ORDERBY' => 'Ortname ASC',
        );
        $mixRes = $this->db->exec_SELECT_queryArray($arrQueryParts);

        // Load order data
        $order = $this->pi_DBgetOrder($this->session['ordernr']);
        // Create each city as new row
        while ($arrData = $this->db->sql_fetch_assoc($mixRes)) {
            // Convert the entries to UTF-8
            // while (list($strKey, $mixValue) = each($arrData)) $arrData[$strKey] = $GLOBALS['TSFE']->csConv($mixValue, 'iso-8859-1');
            // foreach ($arrData as $strKey => $mixValue) {
            //     $arrData[$strKey] = $GLOBALS['TSFE']->csConv($mixValue, 'iso-8859-1');
            // }
            // Setting hightlight class
            $arrData['highlight'] = $bolHighlight ? 'highlight' : '';
            $bolHighlight = !$bolHighlight;
            // Format the prices
            $arrData['termin_gesamtpreis'] = number_format($arrData['termin_gesamtpreis'], 2, ',', '.');
            // Count all locations from this city
            $mixRes2 = $this->db->exec_SELECTquery(
                'DISTINCT termin_standorte,termin_stelle,termin_paechter',
                'Login_termine',
                "termin_auftrag='".$this->session['ordernr']."' AND termin_orte='".$arrData['termin_orte']."'"
            );
            $arrData['termin_standorte'] = $this->db->sql_num_rows($mixRes2);
            if ($order['auftrag_selection'] && $arrData['termin_checked'] != $arrData['termin_summe']) {
                if ($order['auftrag_preis']) {
                    $arrData['termin_gesamtpreis'] = $this->pi_DBgetPrice($this->session['ordernr'], $arrData['termin_orte'], TRUE, TRUE);
                }
                $arrData['termin_summe'] = $arrData['termin_checked'].'/'.$arrData['termin_summe'];
            }
            $strContent .= $this->pi_TPLsubstituteDataMarker($strTemplateLocation, $arrData);
        }

        // Fill the locations into the template
        $strTemplate = $this->cObj->substituteSubpart($strTemplate, '###LOCATIONS###', $strContent);
        // Hide the map
        if ($hideMap) {
            $strTemplate = $this->cObj->substituteSubpart($strTemplate, '###HIDEMAP###', '');
        }

        // Remove the prices if not requested for this order
        $arrOrder = $this->pi_DBgetOrder();
        if (!$arrOrder['auftrag_preis']) {
            $strTemplate = $this->cObj->substituteSubpart($strTemplate, '###SHOWPRICE###', '', 1);
        } else {
            $strTemplate = preg_replace('/<\!-- \#\#\#SHOWPRICE\#\#\# [\w]+ -->/', '', $strTemplate);
        }

        // Create the sums and prices
        $mixRes = $this->db->exec_SELECTquery('*', 'Login_termine', "termin_auftrag='".$this->session['ordernr']."'", "CONCAT_WS(',',termin_standorte,termin_stelle,termin_paechter)");
        $arrData = array(
            'sumLocation' 	=> $this->db->sql_num_rows($mixRes),
            'sumVolume' 	=> $this->pi_DBgetCount(0, 0, TRUE),
            'sumPrice' 		=> $this->pi_DBgetPrice(0, 0, TRUE, TRUE),
            'map_link' 		=> $this->pi_getPageLink($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'mapPage')),
        );

        return $this->pi_TPLsubstituteDataMarker($strTemplate, $arrData);
    }
}


if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/cawlogin/plugins/pi2/class.tx_cawlogin_pi2.php'])	{
    include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/cawlogin/plugins/pi2/class.tx_cawlogin_pi2.php']);
}
