<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2008 Jan Roemich <jroemich@dpi-one.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/


/**
 * ORTSDETAILS
 *
 *
 *
 *   71: class tx_cawlogin_pi3 extends tx_cawlogin_pi
 *
 *              SECTION: Main function
 *  113:     function init()
 *  139:     function main($content, $conf)
 *
 * TOTAL FUNCTIONS: 1
 *
 */























require_once(\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath('cawlogin').'plugins/pi/class.tx_cawlogin_pi.php');


/**
 * Plugin 'CAW Location details' for the 'cawlogin' extension.
 *
 * @author	Jan Roemich <jroemich@dpi-one.de>
 * @package	TYPO3
 * @subpackage	tx_cawlogin
 */
class tx_cawlogin_pi3 extends tx_cawlogin_pi {
    public $prefixId = 'tx_cawlogin_pi3';		// Same as class name
    public $scriptRelPath = 'plugins/pi3/class.tx_cawlogin_pi3.php';	// Path to this script relative to the extension dir.
    public $extKey = 'cawlogin';	// The extension key.
    private $intTotal = 0;
    public $db2 = FALSE;




    /**
     * The main method of the PlugIn
     *
     * @param	string		$strContent: The PlugIn content
     * @param	array		$arrConf: The PlugIn configuration
     * @return	string		The content that is displayed on the website
     */
    public function main($strContent, array $arrConf)	{
        $this->conf = $arrConf;
        $this->pi_setPiVarDefaults();
        $this->pi_loadLL();
        $this->pi_USER_INT_obj = 1;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!
        $this->pi_initPIflexForm();
        // Main initialization
        parent::init();


        if ($this->piVars['mode'] == 'mapmarkers' && $this->piVars['count'] && isset($this->piVars['lngmin']) && isset($this->piVars['lngmax']) && isset($this->piVars['latmin']) && isset($this->piVars['latmax'])) {
            $this->getMapMarkers($this->piVars['count'], $this->piVars['lngmin'], $this->piVars['lngmax'], $this->piVars['latmin'], $this->piVars['latmax'], $this->piVars['zoom'], $this->piVars['categories'], $this->piVars['filter'],$this->piVars['ortnr']);
        } else if ($this->piVars['mode'] == 'mapinfo' && $this->piVars['id']) {
            $this->getMapInfo($this->piVars['id']);
        } else if ($this->piVars['mode'] == 'ajax') {
            $strContent = '';
            $result = array();
            $arrOrder = $this->pi_DBgetOrder();

            if ($arrOrder['auftrag_selection']) {

                if (preg_match('/^[0-9]+$/', $this->piVars['id']) && preg_match('/^[0-9]{7,8}$/', $this->piVars['ort']) && preg_match('/^(1|0)$/', $this->piVars['checked'])) {
                    // Database update
//					$this->db->debugOutput = true;
                    $this->db->exec_UPDATEquery(
                        'Login_termine',
                        "termin_auftrag='".$this->session['ordernr']."' AND termin_order=".$this->db->fullQuoteStr($this->piVars['id'], 'Login_termine')." AND termin_orte=".$this->db->fullQuoteStr($this->piVars['ort'], 'Login_termine'),
                        array('termin_selektion' => $this->piVars['checked'])
                    );

                    $result = array(
                        'city' => array(
                            'volume' => $this->pi_DBgetCount(0, $this->piVars['ort'], TRUE),
                            'price' => ''
                        ),
                        'total' => array(
                            'volume' => $this->pi_DBgetCount(0, $this->piVars['ort'], TRUE),
                            'price' => ''
                        )
                    );

                    if ($arrOrder['auftrag_preis']) {
                        $result['city']['price'] = $this->pi_DBgetPrice(0, $this->piVars['ort'], TRUE, TRUE);

                        $totalPrice = $this->pi_DBgetPrice(0, 0, TRUE, TRUE);
                        $result['total']['price'] = $totalPrice;
                        $result['sumBasket'] = $totalPrice;
                        $result['mapBasket'] = $totalPrice;
                    }


                    // Update the sums
                    // $strContent .= "if (document.getElementById('tx_cawlogin_pi3[city][volume]')) { document.getElementById('tx_cawlogin_pi3[city][volume]').innerHTML = '".$this->pi_DBgetCount(0, $this->piVars['ort'], TRUE)."'; }".chr(10);
                    // $strContent .= "if (document.getElementById('tx_cawlogin_pi3[total][volume]')) { document.getElementById('tx_cawlogin_pi3[total][volume]').innerHTML = '".$this->pi_DBgetCount(0, 0, TRUE)."'; }".chr(10);
                    // // Update prices only if requested from database
                    // if ($arrOrder['auftrag_preis']) {
                    //     $strContent .= "if (document.getElementById('tx_cawlogin_pi3[city][price]')) { document.getElementById('tx_cawlogin_pi3[city][price]').innerHTML = '".$this->pi_DBgetPrice(0, $this->piVars['ort'], TRUE, TRUE) ."'; }".chr(10);

                    //     $totalPrice = $this->pi_DBgetPrice(0, 0, TRUE, TRUE);
                    //     $strContent .= "if (document.getElementById('tx_cawlogin_pi3[total][price]')) { document.getElementById('tx_cawlogin_pi3[total][price]').innerHTML = '".$totalPrice."'; }".chr(10);
                    //     $strContent .= "if (document.getElementById('tx-cawlogin-pi3-sum-basket')) { document.getElementById('tx-cawlogin-pi3-sum-basket').innerHTML = '".$totalPrice."'; }".chr(10);
                    //     $strContent .= "if (document.getElementById('tx-cawlogin-pi3-map-basket')) { document.getElementById('tx-cawlogin-pi3-map-basket').innerHTML = '".$totalPrice."'; }".chr(10);
                    // }
                }
            }
            // Die the javascript content
            if (count($result)) {
                header('Content-Type: application/json');
                return json_encode($result);    
            } else {
                return 'void(0);';
            }
        } elseif (preg_match('/^[0-9]{7,8}$/', $this->piVars['ort'])) {
            if (intval($this->piVars['change']) == 1) {
                if (isset($this->piVars['selectall'])) {
                    $selection = intval($this->piVars['selectall']);
                    $this->changeSelected($selection);
                }
            }
            $this->intTotal = $this->pi_DBgetCount(0, $this->piVars['ort'], FALSE);
            // Set the page number
            $this->piVars['page'] = max(1, min(intval($this->piVars['page']), ceil($this->intTotal / $this->conf['entriesPerPage'])));
            $strContent = $this->showLocations();
            $strContent = $this->showPageNav($strContent, 10);
            //doemedia: Add gmap with same locations
            $strContent = $this->createMap($strContent, $this->piVars['ort']);
        } else {
            $this->pi_redirect($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'redirectOnFailure'));
        }
        // Substitute language, formular and data marker
        $strContent = $this->pi_TPLsubstituteFormularMarker($strContent);
        $strContent = $this->pi_TPLsubstituteDataMarker($strContent, $this->data);
        $strContent = $this->pi_TPLsubstituteLanguageMarker($strContent);
        $this->pi_TPLpublicateJavascript();
        return (string)$this->pi_wrapInBaseClass($strContent);
    }

    protected function changeSelected($selected) {
        $selected = $selected ? 1 : 0;
        $this->db->exec_UPDATEquery('Login_termine', "termin_auftrag='".$this->session['ordernr']."' AND termin_orte=".$this->db->fullQuoteStr($this->piVars['ort'], 'Login_termine'), array('termin_selektion' => $selected));
        #$this->db->exec_UPDATEquery('Login_termine', "termin_auftrag='".$this->session['ordernr']."' AND termin_order=".$this->db->fullQuoteStr($this->piVars['id'], 'Login_termine'), array('termin_selektion' => $selected));
    }

    /***************************
     *
     * Google Maps methods
     *
     **************************/

    /**
     * The getMapHelpLink method of the PlugIn
     *
     * @return	The mailto Helplink with the selected city
     */
    public function getMapHelpLink($strContent, array $arrConf) {
        $this->conf = $arrConf;
        $this->pi_setPiVarDefaults();
        $this->pi_loadLL();
        $this->pi_initPIflexForm();
        parent::init();
        if ($this->piVars['ort']) {
            $id = intval($this->conf['mapBackPageCityID']);
            $ret = '<span class="map_back">'.$this->pi_linkToPage($this->pi_getLL('map_back'), $id, '', array('tx_cawlogin_pi3[ort]' => $this->piVars['ort'])).'</span>';
        } else {
            $id = intval($this->conf['mapBackPageID']);
            $ret = '<span class="map_back">'.$this->pi_linkToPage($this->pi_getLL('map_back'), $id, '', '').'</span>';
        }
        return $ret;
    }

    /**
     * The getMapCategoriesXML method of the PlugIn
     *
     * @return	The xml with categories send back to the ajax caller
     */
    public function getMapCategoriesXML($strContent, array $arrConf) {
        $this->conf = $arrConf;
        $this->pi_setPiVarDefaults();
        $this->pi_loadLL();
        parent::init();
        // create a new xml document
        $xml = new SimpleXMLElement('<mapinfo></mapinfo>');
        // add and set active and inactive elements
        $categories = $xml->addChild('categories');
        $active     = $categories->addChild('active');
        if ($this->piVars['city']) {
            $ortWhere = " AND Login_standorte.standort_ort=".$this->db->fullQuoteStr($this->piVars['city'], 'Login_standorte');
        }
        $queryArray = array(
            'SELECT' => 'DISTINCT Login_standorte.standort_h_anschlag as anschlag',
            'FROM' => 'Login_termine '.
                'INNER JOIN Login_standorte ON (Login_termine.termin_orte=Login_standorte.standort_ort AND Login_termine.termin_standorte=Login_standorte.standort_nummer AND Login_termine.termin_stelle=Login_standorte.standort_stelle AND Login_termine.termin_paechter=Login_standorte.standort_paechter)',
            'WHERE' => "Login_termine.termin_auftrag='".$this->session['ordernr']."'".$ortWhere,
            'GROUPBY' => 'Login_termine.termin_standorte AND Login_termine.termin_stelle AND Login_termine.termin_paechter',
        );
        $res = $this->db->exec_SELECT_queryArray($queryArray);
        while ($row = $this->db->sql_fetch_assoc($res)) {
            $mediaTyp .= ($mediaTyp ? ','.$row['anschlag'] : $row['anschlag'] );
        }
        if ($mediaTyp) {
            $active->addAttribute('values', $mediaTyp);
        }
        return $xml->asXML();
    }

    /**
     * The getMapActualPositionXML method of the PlugIn
     *
     * @return	The xml with categories send back to the ajax caller
     */
    public function getMapActualPositionXML($strContent, array $arrConf) {
        $this->conf = $arrConf;
        $this->pi_setPiVarDefaults();
        $this->pi_loadLL();
        parent::init();
        // create a new xml document
        $xml = new SimpleXMLElement('<mapinfo></mapinfo>');
        // insert the saved coordinates and/or the address
        $actpos = $xml->addChild('actpos');
        if ($this->piVars['city']) {
            $ortWhere = ' AND Login_termine.termin_orte='.$this->db->fullQuoteStr($this->piVars['city'], 'Login_termine');
        }
        $whereCoordinates = " AND wp_Sto.UTMBA LIKE '%.%' AND wp_Sto.UTMBA NOT LIKE '0.%' AND wp_Sto.UTMLA LIKE '%.%' AND wp_Sto.UTMLA NOT LIKE '0.%'";
        $sql = array(
            'SELECT' => 'MIN(wp_Sto.UTMLA) AS lng_min, MAX(wp_Sto.UTMLA) AS lng_max, MIN(wp_Sto.UTMBA) AS lat_min, MAX(wp_Sto.UTMBA) AS lat_max',
            'FROM' => 'Login_termine '.
                'INNER JOIN wp_Sto ON (Login_termine.termin_orte=wp_Sto.OrtNr AND Login_termine.termin_standorte=wp_Sto.StoNr AND Login_termine.termin_stelle=wp_Sto.StoV AND Login_termine.termin_paechter=wp_Sto.Paechter'.$whereCoordinates.') ',
            #'INNER JOIN wp_Sto ON (Login_standorte.standort_ort=wp_Sto.OrtNr AND Login_standorte.standort_nummer=wp_Sto.StoNr AND Login_standorte.standort_stelle=wp_Sto.StoV AND Login_standorte.standort_paechter=wp_Sto.Paechter AND wp_Sto.GJ >= YEAR(CURDATE())) '.
            #'INNER JOIN Login_termine ON (Login_termine.termin_standorte=Login_standorte.standort_nummer)',
            'WHERE' => "Login_termine.termin_auftrag='".$this->session['ordernr']."'".$ortWhere,
        );
        $res = $this->db->exec_SELECT_queryArray($sql);
        if ($row = $this->db->sql_fetch_assoc($res)) {
            if ($row['lng_min'] && $row['lng_max']) $actpos->lng = ($row['lng_min'] + $row['lng_max']) / 2;
            if ($row['lat_min'] && $row['lat_max']) $actpos->lat = ($row['lat_min'] + $row['lat_max']) / 2;
            if ($row['center_lat']) $actpos->lat = $row['center_lat'];
            #if ($row['center_lng']) $actpos->lng = $row['center_lng'];
            #if ($row['center_lat']) $actpos->lat = $row['center_lat'];
            if ($row['lng_min']) $actpos->addAttribute('north', $row['lng_min']);
            if ($row['lng_max']) $actpos->addAttribute('south', $row['lng_max']);
            if ($row['lat_min']) $actpos->addAttribute('west', $row['lat_min']);
            if ($row['lat_max']) $actpos->addAttribute('east', $row['lat_max']);
        }
        return $xml->asXML();
    }

    /**
     * The getMapMenu method of the PlugIn
     *
     * @return	The html-menu-content that is displayed on the website
     */
    protected function getMapMenu($strContent, array $arrConf) {
        $content = '';
        return $this->pi_wrapInBaseClass($content);
    }

    /**
     * The getMapScript method of the PlugIn
     *
     * @return	The javascript-content
     */
    public function getMapScript($strContent, array $arrConf) {
        $this->conf = $arrConf;
        $this->pi_setPiVarDefaults();
        $this->pi_loadLL();
        parent::init();
        // Create array for substitution into javascript
        $marks = array(
            'URL'			=> $this->pi_getPageLink($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'linkSelect')),
            'DATA_ajaxUrl'	=> $this->pi_getPageLink(
                $this->conf['selfPageID'], 
                '', 
                array(
                    'type' => '100', 
                    $this->prefixId.'[mode]' => 'ajax', 
                    $this->prefixId.'[id]' => $GLOBALS['TSFE']->id,
                    $this->prefixId.'[ort]' => $this->piVars['ort'],
                    $this->prefixId.'[checked]' => 1
                )
            ),
        );
        // Load javascript template
        $strFileResource = $this->cObj->stdWrap($this->conf['javascriptFile'], $this->conf['javascriptFile.']);
        $strContent = $this->cObj->fileResource($strFileResource);
        $strContent = $this->cObj->getSubpart($strContent, '###'.$this->prefixId.'###');
        // Substitute marker
        $strContent = $this->pi_TPLsubstituteLanguageMarker($strContent);
        $strContent = $this->cObj->substituteMarkerArray($strContent, $marks, "###|###");
        // return javascript content
        return $strContent;
    }

    /**
     * The getMapPrices method of the PlugIn
     *
     * @return	The javascript-content
     */
    public function getMapPrices($strContent, array $arrConf) {
        $this->conf = $arrConf;
        $this->pi_setPiVarDefaults();
        $this->pi_loadLL();
        parent::init();
        $strFileResource = $this->cObj->stdWrap($this->conf['templateFile'], $this->conf['templateFile.']);
        $strTemplate = $this->cObj->fileResource($strFileResource);
        if ($this->piVars['city']) {
            $strTemplate = $this->cObj->getSubpart($strTemplate, '###google_maps_map_city_price###');
        } else {
            $strTemplate = $this->cObj->getSubpart($strTemplate, '###google_maps_map_price###');
        }
        $arrCity = $this->pi_DBgetCityInfo($this->piVars['city']);
        $arrMarks = array(
            'cityName' => $GLOBALS['TSFE']->csConv($arrCity['Ortname'], 'iso-8859-1'),
            'totalPrice' => $this->pi_DBgetPrice(0, 0, TRUE, TRUE),
            'totalVolume' => $this->pi_DBgetCount(0, 0, TRUE),
            'cityPrice' => $this->pi_DBgetPrice(0, $this->piVars['city'], TRUE, TRUE),
            'cityVolume' => $this->pi_DBgetCount(0, $this->piVars['city'], TRUE),
        );
        $strTemplate = $this->pi_TPLsubstituteLanguageMarker($strTemplate);
        $strTemplate = $this->pi_TPLsubstituteDataMarker($strTemplate, $arrMarks);
        $arrOrder = $this->pi_DBgetOrder();
        if (!$arrOrder['auftrag_preis']) {
            $strTemplate = $this->cObj->substituteSubpart($strTemplate, '###SHOWPRICE###', '', 1);
        } else {
            $strTemplate = preg_replace('@<!--[\s]+###SHOWPRICE###[\s]+[A-Z0-9\s]*?-->@si', '', $strTemplate);
        }
        return $this->pi_wrapInBaseClass($strTemplate);
    }

    /**
     * The getMapMarkers method of the PlugIn
     *
     * @param	integer		$count: number of markers
     * @param 	float		$lng_min: minimal longitude in bouding rectangle of the map
     * @param 	float		$lng_max: maximal longitude in bouding rectangle of the map
     * @param 	float		$lat_min: minimal latitude in bouding rectangle of the map
     * @param 	float		$lat_max: maxiimal latitude in bouding rectangle of the map
     * @param	integer		$zoom: The zoom factor of the map
     * @param 	string		$categories: List with selected/active categories
     * @param	boolean		$filter: is filter active?
     * @return	The xml-marker-content that is send back to the ajax caller
     */
    protected function getMapMarkers($count, $lng_min, $lng_max, $lat_min, $lat_max, $zoom=1, $categories='', $filter=0, $ortnr='') {
        $andWhere = '';
        if ($ortnr && is_numeric($ortnr)) {
            $andWhere .= ' AND standort_ort='.$this->db->fullQuoteStr($ortnr, 'Login_standorte');
        }
        if ($categories && strtolower($categories) != 'all') {
            $andWhere .= ' AND standort_h_anschlag IN('.implode(',', $this->db->fullQuoteArray(\TYPO3\CMS\Core\Utility\GeneralUtility::trimExplode(',', $categories, 1), 'Login_standorte')).')';
        }
        //$whereCoordinates = " AND wp_Sto.UTMBA LIKE '%.%' AND wp_Sto.UTMBA NOT LIKE '0.%' AND wp_Sto.UTMLA LIKE '%.%' AND wp_Sto.UTMLA NOT LIKE '0.%'";
        $queryArray = array(
            'SELECT' => 'DISTINCT standort_ort,standort_nummer,standort_stelle,standort_paechter,standort_h_anschlag',
            'FROM' => 'Login_standorte '.
                'INNER JOIN Login_termine ON (termin_orte=standort_ort AND termin_standorte=standort_nummer AND termin_stelle=standort_stelle AND termin_paechter=standort_paechter)',
            'WHERE' => "termin_auftrag='".$this->session['ordernr']."'".$andWhere,
        );
        $res = $this->db->exec_SELECT_queryArray($queryArray);
        // create a new xml document
        $xml = new SimpleXMLElement('<map></map>');
        $xmlMapInfo = $xml->addChild('mapinfo');
        #$xmlMapInfo->addAttribute('pages',intval($rowInfo / $count ));
        #$xmlMapInfo->addAttribute('actPage', intval($this->piVars['page']));
        $xmlMapInfo->addAttribute('markerShown', $count);
        $xmlMapInfo->addAttribute('markerCount', $this->db->sql_num_rows($res));
        $xmlMarkers = $xml->addChild('markers');
        // put all locations and infos to the xml document
        $arrSto = array();
        while ($row = $this->db->sql_fetch_assoc($res)) {
            if (!in_array($row['standort_nummer'].'-'.$row['standort_stelle'].'-'.$row['standort_paechter'], $arrSto)) {
                $coordinates = $this->getCoordinates($row['standort_ort'], $row['standort_nummer'], $row['standort_stelle'], $row['standort_paechter'], $lng_min, $lng_max, $lat_min, $lat_max);
                if ($coordinates['UTMBA'] && $coordinates['UTMLA']) {
                    $xmlSingleMarker = $xmlMarkers->addChild('marker');
                    $xmlSingleMarker->addAttribute('lat', $coordinates['UTMBA']);
                    $xmlSingleMarker->addAttribute('lng', $coordinates['UTMLA']);
                    $xmlSingleMarker->addAttribute('id', $row['standort_nummer'].'-'.$row['standort_stelle'].'-'.$row['standort_paechter']);
                    $xmlSingleMarker->addAttribute('icon', $row['standort_h_anschlag']);
                    $arrSto[] = $row['standort_nummer'].'-'.$row['standort_stelle'].'-'.$row['standort_paechter'];
                }
            }
        }
        // send the xml data to the ajax requester
        header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
        header('Content-Type: text/xml');
        die($xml->asXML());
    }

    protected function getCoordinates($ort, $stonr, $stov, $paechter, $lng_min, $lng_max, $lat_min, $lat_max) {
        //$whereCoordinates = " AND (UTMBA BETWEEN $lat_min AND $lat_max) AND (UTMLA BETWEEN $lng_min AND $lng_max)";
        $queryArray = array(
            'SELECT' =>	'UTMBA,UTMLA',
            'FROM' => 'wp_Sto',
            'WHERE' => 'wp_Sto.OrtNr='.$this->db->fullQuoteStr($ort, 'wp_Sto').' AND wp_Sto.StoNr='.$this->db->fullQuoteStr($stonr, 'wp_Sto').' AND wp_Sto.StoV='.$this->db->fullQuoteStr($stov, 'wp_Sto').' AND wp_Sto.Paechter='.$this->db->fullQuoteStr($paechter, 'wp_Sto'),//.$whereCoordinates,
            'LIMIT' => '1',
        );
        $res = $this->db->exec_SELECT_queryArray($queryArray);
        return $this->db->sql_num_rows($res) ? (array)$this->db->sql_fetch_assoc($res) : array();
    }

    /**
     * The getMapInfo method of the PlugIn
     *
     * @param	int		$id: The id of the marker
     * @return	The html-marker-info content that is send back to the ajax caller
     */
    protected function getMapInfo($id) {

        $strFileResource = $this->cObj->stdWrap($this->conf['templateFile'], $this->conf['templateFile.']);
        $strTemplate = $this->cObj->getSubpart($this->cObj->fileResource($strFileResource), '###TEMPLATE_MAP_INFO###');
        // $strTemplateDate = $this->cObj->getSubpart($strTemplate, '###DATES_REPETITION###');
        $strContent = '';

        // get the location info for the given location id
        $arrQueryParts = array(
            'SELECT' => 'Login_termine.*, Login_standorte.*, Login_HS.Bezeichnung AS bez_HS, Login_US.Bezeichnung AS bez_US, wp_Ort.*',
            'FROM' => 'Login_termine '.
                'LEFT JOIN (Login_standorte) ON (Login_termine.termin_standorte=Login_standorte.standort_nummer AND Login_termine.termin_stelle=Login_standorte.standort_stelle AND Login_termine.termin_paechter=Login_standorte.standort_paechter AND Login_termine.termin_orte=Login_standorte.standort_ort) '.
                'LEFT JOIN (Login_HS) ON (Login_standorte.standort_h_anschlag=Login_HS.HS) '.
                'LEFT JOIN (Login_US) ON (Login_standorte.standort_h_anschlag=Login_US.HS AND Login_standorte.standort_u_anschlag=Login_US.US) '.
                "LEFT JOIN (wp_Ort) ON (Login_termine.termin_orte=wp_Ort.OrtNr AND wp_Ort.Staat='D' AND wp_Ort.Sperre='-1')",
            'WHERE' => "termin_auftrag='".$this->session['ordernr']."' AND CONCAT_WS('-', Login_standorte.standort_nummer, Login_standorte.standort_stelle, Login_standorte.standort_paechter)=".$this->db->fullQuoteStr($id, 'Login_standorte'),
        );
        $mixRes = $this->db->exec_SELECT_queryArray($arrQueryParts);
        while ($arrRow = $this->db->sql_fetch_assoc($mixRes)) {
            // foreach ($arrRow as $strKey => $mixVal) $arrRow[$strKey] = $GLOBALS['TSFE']->csConv($mixVal, 'iso-8859-1');
            $imgConf = array(
                'cObject' => $this->conf['locationInfoWindow'],
                'conf' => $this->conf['locationInfoWindow.']
            );
            $arrRow['standort_foto'] = $this->createImage($arrRow['standort_foto'], $arrRow['standort_name'], $arrRow, $imgConf);
            $arrRow['standort_tagespreis'] = number_format(floatval($arrRow['standort_tagespreis']), 2, ',', '.');
            $arrRow['termin_preis'] = number_format(floatval($arrRow['termin_preis']), 2, ',', '.');

            if (empty($arrRow['bez_HS'])) $arrRow['bez_HS'] =  $arrRow['standort_h_anschlag'];
            if (empty($arrRow['bez_US'])) $arrRow['bez_US'] =  $arrRow['standort_u_anschlag'];

            $arrRow['Bezeichnung'] = !empty($arrRow['bez_US']) ? $arrRow['bez_US'] : $arrRow['bez_HS'];//doemedia: Wie kommt "Bezeichnung" zustande?

            // $arrQueryParts2 = array(
            //     'SELECT' => 'wp_Sto.PLZ,wp_Sto.Bewertung,wp_Sto.GJ,wp_Sto.StoID',
            //     'FROM' => 'wp_Sto',
            //     'WHERE' => "'StoNr='".$arrRow['termin_standorte']."'"
            // );
            // $mixRes2 = $this->db->exec_SELECT_queryArray($arrQueryParts2);
            // $arrRowData2 = $this->db->sql_fetch_assoc($mixRes2);
            // if($arrRowData2) {
            //     die('HÄ?');
            //     $arrRow['PLZ'] = $arrRowData2['PLZ'];
            //     $arrRow['Bewertung'] = $arrRowData2['Bewertung'];
            //     $arrRow['GJ'] = $arrRowData2['GJ'];
            //     $arrRow['StoID'] = $arrRowData2['StoID'];
            // }

            //More information of a location
            $arrQueryParts4 = array(
                'SELECT' => 'wp_Sto.GJ, wp_Sto.PLZ, wp_Sto.Bewertung, wp_LWTD.Leistungswert AS PpS',
                'FROM' => 'wp_Sto INNER JOIN (wp_LWTD) ON (wp_Sto.StoID=wp_LWTD.StoID)',
                'WHERE' => "wp_Sto.OrtNr='".$arrRow['standort_ort']."' AND wp_Sto.Paechter='".$arrRow['standort_paechter']."' AND wp_Sto.StoNr='".$arrRow['standort_nummer']."' AND wp_Sto.StoV='".$arrRow['standort_stelle']."' AND wp_Sto.HS='".$arrRow['standort_h_anschlag']."' AND wp_Sto.US='".$arrRow['standort_u_anschlag']."'",
            );
            $mixRes4 = $this->db->exec_SELECT_queryArray($arrQueryParts4);
            $arrRowData2 = $this->db->sql_fetch_assoc($mixRes4);
            // Copy value of Bewertung for rating image
            $arrRowData2['Rating'] = $arrRowData2['Bewertung'];
            $arrRow = array_merge($arrRow, $arrRowData2);

            $arrQueryParts3 = array(
                'SELECT' => 'BTage',
                'FROM' => 'wp_ZR',
                'WHERE' => "Beginn='".$arrRow['termin_beginn']."' AND ZR='".$arrRow['termin_dekade']."'",
            );
            $mixRes3 = $this->db->exec_SELECT_queryArray($arrQueryParts3);
            $arrRow3 = $this->db->sql_fetch_assoc($mixRes3);

            // Termin Ende und Tage
            if ($arrRow3) {
                $arrRow['BTage'] = $arrRow3['BTage'] . ' Tage';
                //doemedia
                $arrRow['termin_end'] = date('Y-m-d', strtotime($arrRow['termin_beginn']) + ($arrRow3['BTage'] * 86400));
            }

            // PpS - doemedia
            // $arrQueryParts4 = array(
            //     'SELECT' => 'Leistungswert',
            //     'FROM' => 'wp_LWTD',
            //     'WHERE' => "StoID='".$arrRowData2['StoID']."'",
            // );
            // $mixRes4 = $this->db->exec_SELECT_queryArray($arrQueryParts4);
            // $arrRowData4 = $this->db->sql_fetch_assoc($mixRes4);
            // if($arrRowData4) {
            //     $arrRow['PpS'] = $arrRowData4['Leistungswert'];
            // }

            $arrRow['checked'] = ($arrRow['termin_selektion'] == 1) ? ' checked' : '';

            $strContent .= $this->pi_TPLsubstituteDataMarker($strTemplate, $arrRow);
        }

        $this->db->sql_free_result($mixRes);
        // set the template to the output content (for substitution)
        // create the checkboxes - doemedia: by default
        // $strTemplate = $this->cObj->substituteSubpart($strTemplate, '###DATES_REPETITION###', $strContent);
        $strContent = $this->pi_TPLsubstituteLanguageMarker($strContent);
        $strContent = $this->pi_TPLsubstituteFormularMarker($strContent);
        $arrOrder = $this->pi_DBgetOrder();

        if (!$arrOrder['auftrag_preis']) {
            $strContent = $this->cObj->substituteSubpart($strContent, '###SHOWPRICE###', '', 1);
        }
        // Remove checkboxes if the order is not editable
        if (!$arrOrder['auftrag_selection']) {
            $strContent = $this->cObj->substituteSubpart($strContent, '###SHOWSELECT###', '', 1);
        }
        return $strContent;
    }


    /**
     * The getMapInfo method of the PlugIn
     *
     * @param	string		$content: The JSON content
     * @param	array		$conf: The id of the marker
     * @return	The html-marker-info content that is send back to the ajax caller
     */
    public function getMapMarkersAsJson($content, $conf) {
        $this->conf = $conf;
        $this->pi_setPiVarDefaults();
        $this->pi_loadLL();
        $this->pi_USER_INT_obj = 1;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!
        $this->pi_initPIflexForm();
        // Main initialization
        parent::init();

        $locations = array();
        $piVars = \TYPO3\CMS\Core\Utility\GeneralUtility::_GP('tx_cawlogin_pi3');
        $ortnr = isset($piVars['ort']) ? $piVars['ort'] : 0;
        $andWhere = '';
        if ($ortnr) {
            $andWhere .= ' AND OrtNr=' . $this->db->fullQuoteStr($ortnr, 'wp_Sto');
        }

        //$whereCoordinates = " AND wp_Sto.UTMBA LIKE '%.%' AND wp_Sto.UTMBA NOT LIKE '0.%' AND wp_Sto.UTMLA LIKE '%.%' AND wp_Sto.UTMLA NOT LIKE '0.%'";
        $queryArray = array(
            'SELECT' => 'UTMLA, UTMBA, StoNr, HS, StoV, Paechter',
            'FROM' => 'Login_termine ' .
                'LEFT JOIN wp_Sto ON (termin_standorte=StoNr AND termin_stelle=StoV AND termin_paechter=Paechter AND termin_orte=OrtNr)',
            'WHERE' => 'termin_auftrag="' . $this->session['ordernr'] . '"' . $andWhere
        );
        $res = $this->db->exec_SELECT_queryArray($queryArray);
        if($this->db->sql_num_rows($res)) {
            while($row = $this->db->sql_fetch_assoc($res)) {

                $row['type'] = $row['HS'];
                unset($row['HS']);

                $row['id'] = sprintf('%02d',$row['StoNr']) . '-' . sprintf('%02d', $row['StoV']) . '-' . $row['Paechter'];

                $this->conf['MAP_INFOWINDOW_URL.']['typolink.']['additionalParams'] = '&tx_cawlogin_pi3[id]=' . $row['id'];
                $row['url'] =  $this->cObj->cObjGetSingle($this->conf['MAP_INFOWINDOW_URL'], $this->conf['MAP_INFOWINDOW_URL.']);

                $locations[] = $row;
            }


        }

        $content = json_encode($locations);

        return $content;
    }

    /**
     * The getMapInfo method of the PlugIn
     *
     * @param	string		$content: The JSON content
     * @param	array		$conf: The id of the marker
     * @return	The html-marker-info content that is send back to the ajax caller
     */
    public function getMapMarkerInfoWindow($content, $conf) {
        $content = '';
        $this->conf = $conf;
        $this->pi_setPiVarDefaults();
        $this->pi_loadLL();
        $this->pi_USER_INT_obj = 1;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!
        $this->pi_initPIflexForm();
        // Main initialization
        parent::init();

        $piVars = \TYPO3\CMS\Core\Utility\GeneralUtility::_GP('tx_cawlogin_pi3');
        $id = isset($piVars['id']) && !empty($piVars['id']) ? $piVars['id'] : 0;

        if($id) {
            $content = $this->getMapInfo($id);
        }

        return $content;
    }
    /***************************
     *
     * Standard View methods
     *
     **************************/





    /**
     * The showLocationDetails method of the PlugIn
     *
     * @param	integer		$locationnr: The location number
     * @param	integer		$page: The current page for the page browser
     * @param	integer		$maxEntries: The number of entries show per page
     * @return	string		The content that is displayed on the website
     */
    private function showLocations() {
        // Get the template
        $strFileResource = $this->cObj->stdWrap($this->conf['templateFile'], $this->conf['templateFile.']);
        $strTemplate = $this->cObj->fileResource($strFileResource);
        $strTemplate = $this->cObj->getSubpart($strTemplate, '###'.$this->prefixId.'###');

        // Define variables
        $intI = $this->conf['entriesPerPage'];
        $bolHighlight = FALSE;
        $strContent = '';
        $mixLastLocation = '';
        $mixLastLocationPart = '';

        // Show or hide the map
        $arrQueryParts = array(
            'SELECT' => 'Staat,Belegung',
            'FROM' => 'Login_termine LEFT JOIN wp_Sto ON(termin_standorte=StoNr AND termin_stelle=StoV AND termin_paechter=Paechter AND termin_orte=OrtNr)',
            'WHERE' => "termin_auftrag='".$this->session['ordernr']."' AND termin_orte=".$this->db->fullQuoteStr($this->piVars['ort'], 'Login_termine')." AND UTMLA NOT IN('0', '0.0', '') AND UTMBA NOT IN('0', '0.0', '')",
            'GROUPBY' => '',
            'ORDERBY' => '',
            'LIMIT' => '1',
        );
        $mixRes0 = $this->db->exec_SELECT_queryArray($arrQueryParts);
        $hideMap = !$this->db->sql_num_rows($mixRes0);
        $arrRow0 = $this->db->sql_fetch_assoc($mixRes0);
        $hideDecade = $arrRow0['Staat'] == 'A' || $arrRow0['Belegung'] == 'HM';
        $this->db->sql_free_result($mixRes0);

        // Create the SQL statement
        $arrQueryParts = array(
            'SELECT' => '*,Login_HS.Bezeichnung AS bez_HS,Login_US.Bezeichnung AS bez_US',
            'FROM' => 'Login_termine
				LEFT JOIN (Login_standorte) ON (termin_standorte=standort_nummer AND termin_stelle=standort_stelle AND termin_paechter=standort_paechter AND termin_orte=standort_ort)
				LEFT JOIN (Login_HS) ON (Login_standorte.standort_h_anschlag=Login_HS.HS)
				LEFT JOIN (Login_US) ON (Login_standorte.standort_h_anschlag=Login_US.HS AND Login_standorte.standort_u_anschlag=Login_US.US)
				',
            'WHERE' => "termin_auftrag='".$this->session['ordernr']."' AND termin_orte=".$this->db->fullQuoteStr($this->piVars['ort'], 'Login_termine'),
            'ORDERBY' => 'standort_name ASC,standort_nummer ASC,termin_stelle ASC,termin_beginn ASC',
            'LIMIT' => (($this->piVars['page'] - 1) * $this->conf['entriesPerPage']).",".$this->conf['entriesPerPage'],
        );
        $mixRes = $this->db->exec_SELECT_queryArray($arrQueryParts);

        // Create each decade as new row
        while ($arrRow = $this->db->sql_fetch_assoc($mixRes)) {

            $arrQueryParts3 = array(
                'SELECT' => '*',
                'FROM' => 'wp_ZR',
                'WHERE' => "Beginn='".$arrRow['termin_beginn']."' AND ZR='".$arrRow['termin_dekade']."'",
            );
            $mixRes2 = $this->db->exec_SELECT_queryArray($arrQueryParts3);
            $arrRow2 = $this->db->sql_fetch_assoc($mixRes2);

            if ($arrRow2) {
                $arrRow['BTage'] = $arrRow2['BTage'] . ' Tage';
                //doemedia
                $arrRow['termin_end'] = date('Y-m-d', strtotime($arrRow['termin_beginn']) + ($arrRow2['BTage'] * 86400));
                $arrRow['termin_year'] = $arrRow2['GJ'];
                $arrRow['termin_dekade'] = $arrRow2['ReferenzDekade'];
            }

            // Store the unique location number
            $mixUniqueId = $arrRow['standort_nummer'].'|'.$arrRow['standort_stelle'].'|'.$arrRow['standort_paechter'];
            // Convert the entries to UTF-8
            // while (list($strKey, $mixValue) = each($arrRow)) $arrRow[$strKey] = $GLOBALS['TSFE']->csConv($mixValue, 'iso-8859-1');
//            foreach ($arrRow as $strKey => $mixValue) {
//                $arrRow[$strKey] = $GLOBALS['TSFE']->csConv($mixValue, 'iso-8859-1');
//            }
            // Get the location template
            $strTemplateLocation = $this->cObj->getSubpart($strTemplate, '###LOCATIONS###');
            // Do not display location name and details
            if ($mixLastLocation == $mixUniqueId && $mixLastLocationPart == $arrRow['termin_stelle']) {
                $strTemplateDetails = '';
                // Display location name and details
            } else {
                $strTemplateDetails = $this->cObj->getSubpart($strTemplateLocation, '###LOCATION_DETAILS###');
                $strTemplateMarket = '';
                $mixLastLocation = $mixUniqueId;
                $mixLastLocationPart = $arrRow['termin_stelle'];
                $imgConf = array(
                    'cObject' => $this->conf['locationImage'],
                    'conf' => $this->conf['locationImage.']
                );
                $arrRow['standort_foto'] = $this->createImage($arrRow['standort_foto'], $arrRow['standort_name'], $arrRow, $imgConf);
                if (empty($arrRow['bez_HS'])) $arrRow['bez_HS'] =  $arrRow['standort_h_anschlag'];
                if (empty($arrRow['bez_US'])) $arrRow['bez_US'] =  $arrRow['standort_u_anschlag'];

                // Get the market information
                if ($arrRow['standort_ekznr']) {
                    $arrQueryParts3 = array(
                        'SELECT' => 'VMName,VMKette',
                        'FROM' => 'wp_VMarkt',
                        'WHERE' => "Paechter='".$arrRow['standort_paechter']."' AND VMNr='".$arrRow['standort_ekznr']."' AND OrtNr='".$arrRow['standort_ort']."'",
                        'ORDERBY' => 'GJ DESC',
                        'LIMIT' => '1',
                    );
                    $mixRes3 = $this->db->exec_SELECT_queryArray($arrQueryParts3);
                    if ($this->db->sql_num_rows($mixRes3) == 1) {
                        $strTemplateMarket = $this->cObj->getSubpart($strTemplateDetails, '###MARKET###');
                        $arrRow2 = $this->db->sql_fetch_assoc($mixRes3);
                        // Convert the entries to UTF-8
                        // while (list($strKey, $mixValue) = each($arrRow2)) $arrRow2[$strKey] = $GLOBALS['TSFE']->csConv($mixValue, 'iso-8859-1');
                        // foreach ($arrRow2 as $strKey2 => $mixValue2) {
                        //     $arrRow2[$strKey2] = $GLOBALS['TSFE']->csConv($mixValue2, 'iso-8859-1');
                        // }
                        $arrRow = array_merge($arrRow, $arrRow2);
                        $arrRow['standort_foto_vm'] = $this->createImageMarket($arrRow);
                    }
                }
                $strTemplateDetails = $this->cObj->substituteSubpart($strTemplateDetails, '###MARKET###', $strTemplateMarket);

                // Calculate the rowspan
                // $arrQueryParts2 = array(
                //     'SELECT' => '*',
                //     'FROM' => $arrQueryParts['FROM'],
                //     'WHERE' => $arrQueryParts['WHERE']." AND termin_standorte='".$arrRow['termin_standorte']."' AND termin_stelle='".$arrRow['termin_stelle']."' AND termin_paechter='".$arrRow['termin_paechter']."' AND termin_beginn>='".$arrRow['termin_beginn']."'",
                //     'ORDERBY' => $arrQueryParts['ORDERBY'],
                //     'LIMIT' => '0,'.$intI,
                // );
                // $mixRes2 = $this->db->exec_SELECT_queryArray($arrQueryParts2);
                // $arrRow['rowspan'] = $this->db->sql_num_rows($mixRes2);
                // $bolHighlight = !$bolHighlight;

                //More information of a location
                $arrQueryParts4 = array(
                    'SELECT' => 'wp_Sto.PLZ, wp_Sto.Bewertung, wp_LWTD.Leistungswert AS PpS',
                    'FROM' => 'wp_Sto INNER JOIN (wp_LWTD) ON (wp_Sto.StoID=wp_LWTD.StoID)',
                    'WHERE' => "wp_Sto.OrtNr='".$arrRow['standort_ort']."' AND wp_Sto.Paechter='".$arrRow['standort_paechter']."' AND wp_Sto.StoNr='".$arrRow['standort_nummer']."' AND wp_Sto.StoV='".$arrRow['standort_stelle']."' AND wp_Sto.HS='".$arrRow['standort_h_anschlag']."' AND wp_Sto.US='".$arrRow['standort_u_anschlag']."'",
                );
                $mixRes4 = $this->db->exec_SELECT_queryArray($arrQueryParts4);
                $arrRowData2 = $this->db->sql_fetch_assoc($mixRes4);
                // Copy value of Bewertung for rating image
                $arrRowData2['Rating'] = $arrRowData2['Bewertung'];
                $arrRow = array_merge($arrRow, $arrRowData2);
            }

            // Update the location template
            $strTemplateLocation = $this->cObj->substituteSubpart($strTemplateLocation, '###LOCATION_DETAILS###', $strTemplateDetails);
            // Manipulate some data
            $arrRow['termin_preis'] = number_format($arrRow['termin_preis'], 2, ',', '.');
            $arrRow['standort_tagespreis'] = number_format($arrRow['standort_tagespreis'], 2, ',', '.');
            $arrRow['highlight'] = $bolHighlight ? ' class="highlight"' : '';
            $arrRow['checked'] = ($arrRow['termin_selektion'] == 1) ? ' checked' : '';
            $intI--;
            // Append this location to the template
            $strContent .= $this->pi_TPLsubstituteDataMarker($strTemplateLocation, $arrRow);
        }
        // Insert the locations into the template
        $strTemplate = $this->cObj->substituteSubpart($strTemplate, '###LOCATIONS###', $strContent);


        // Remove prices or checkboxes if prices had not to be displayed or the order is not editable
        $arrOrder = $this->pi_DBgetOrder();
        // Remove prices if prices had not to be displayed
        if (!$arrOrder['auftrag_preis']) {
            $strTemplate = $this->cObj->substituteSubpart($strTemplate, '###SHOWPRICE###', '', 1);
        } else {
            $strTemplate = preg_replace('@<!--[\s]+###SHOWPRICE###[\s]+[A-Z0-9\s]*?-->@si', '', $strTemplate);
        }
        // Remove checkboxes if the order is not editable
        if (!$arrOrder['auftrag_selection']) {
            $strTemplate = $this->cObj->substituteSubpart($strTemplate, '###SHOWSELECT###', '', 1);
        }  else {
            $strTemplate = preg_replace('@<!--[\s]+###SHOWSELECT###[\s]+[A-Z0-9\s]*?-->@si', '', $strTemplate);
        }

        // Create the TYPO3 mouseOver actions for the plus minus icons
//        $this->createMouseOver();

        $isSelected =$this->isSelected($this->session['ordernr'], $this->piVars['ort']);
        $changeSelectAll = ($isSelected['cnt'] == $isSelected['sm']) ? '0' : '1';
        $selected = ($isSelected['cnt'] == $isSelected['sm']) ? ' checked' : ' ';




        // Create global data markers
        $mixRes = $this->db->exec_SELECTquery('Ortname', 'wp_Ort', "Staat='D' AND OrtNr=".$this->db->fullQuoteStr($this->piVars['ort'], 'wp_Ort'));
        $arrData = array(
            'cityName' 		=> @current($this->db->sql_fetch_row($mixRes)),
            'cityVolume' 	=> $this->pi_DBgetCount(0, $this->piVars['ort'], TRUE),
            'cityPrice' 	=> $this->pi_DBgetPrice(0, $this->piVars['ort'], TRUE, TRUE),
            'totalVolume' 	=> $this->pi_DBgetCount(0, 0, TRUE),
            'totalPrice' 	=> $this->pi_DBgetPrice(0, 0, TRUE, TRUE),
            'map_link'		=> $this->pi_getPageLink(
                $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'mapPage'),
                '' ,
                array('tx_cawlogin_pi3[ort]'=>$this->piVars['ort'])
            ),
            'map_markers_link'		=> $this->pi_getPageLink(
                $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'mapPage'),
                '' ,
                array(
                    'tx_cawlogin_pi3[ort]'=>$this->piVars['ort'],
                    'tx_cawlogin_pi3[id]'=>$GLOBALS['TSFE']->id,
                    'tx_cawlogin_pi3[checked]'=>1
                )
            ) . '&type=100',
            'changeChecked' => $selected,
            'selectall_value' => $changeSelectAll,
            'OrtNr' => $this->piVars['ort']
        );

        if ($arrOrder['auftrag_preis'] && $arrOrder['auftrag_selection']) {
            $arrData['sumBasket'] = $arrData['totalPrice'];
        }

        // Show the map
        $strTemplate = $this->cObj->substituteSubpart($strTemplate, '###SHOW_MAP###', $this->cObj->getSubpart($strTemplate, '###SHOW_MAP###'));
        // Hide the map
        if ($hideMap) {
            $strTemplate = $this->cObj->substituteSubpart($strTemplate, '###HIDEMAP###', '');
        }

        if ($hideDecade) {
            $this->pi_LLset('headerDecade', $this->pi_LLget('headerDecade2'));
            $this->pi_LLset('headerSubtitle', $this->pi_LLget('headerSubtitle2'));
        }

        // Return the template
        return (string)$this->pi_TPLsubstituteDataMarker($strTemplate, $arrData);
    }

    /**
     * The getMapMarkers method of the PlugIn
     *
     * @param   string      $strContent: Content from template
     * @return	The content that is a template for gmap
     */
    protected function createMap($strContent) {
        $arrMap = array();
        $arrMap['link'] = $this->pi_getPageLink($GLOBALS['TSFE']->id);;
        $arrMap['logo_link'] = $this->pi_getPageLink((int)$this->conf['homeID']);
        $arrMap['logo'] = $this->cObj->cObjGetSingle($this->conf['mapLogo'], $this->conf['mapLogo.']);
        $arrMap['phone'] = isset($this->conf['phone']) ? $this->conf['phone'] : '';

        // Get the template for displaying the buttons
        $strTemplate = $this->cObj->getSubpart($strContent, '###LOCATIONSMAP###');
        // Substitute the map settings
        $strTemplate = $this->cObj->substituteMarkerArray($strTemplate, $arrMap, '###MAP_|###');
        // Replace the map into the template
        return (string)$this->cObj->substituteSubpart($strContent, '###LOCATIONSMAP###', $strTemplate);
    }

    /**
     * Checks the count of possible selections and the actual selected; return array with both values
     *
     * @param	integer		$order
     * @param	integer		$city
     * @return	array
     */
    protected function isSelected($order, $city) {
        $sql = array(
            'SELECT' => 'COUNT(*) as cnt, SUM(termin_selektion) as sm',
            'FROM' => 'Login_termine',
            'WHERE' => 'termin_auftrag='.$this->db->fullQuoteStr($order, 'Login_termine').' AND termin_orte='.$this->db->fullQuoteStr($city, 'Login_termine'),
        );
        $res = $this->db->exec_SELECT_queryArray($sql);
        return $this->db->sql_num_rows($res) ? (array)$this->db->sql_fetch_assoc($res) : array();
    }

    /**
     * Creates the image for the given entry
     *
     * @param	string		$fileName: The file name
     * @param	string		$fileTitle: The title for the new window that is opened if the user clicks on the thumbnail image
     * @return	string		The Image of the given entry or the "nopic" picture
     */
    private function createImage($strFileName, $strFileTitle, $arrRow=FALSE, $imageConf = array()) {
        $arrConf = $imageConf['conf'];
        $found = FALSE;
        // The location image exists
        if (is_file($arrConf['file.']['import'].str_replace('--', '/', $strFileName))) {
            $arrConf['file.']['import.']['override'] = str_replace('--', '/', $strFileName);
            $arrConf['imageLinkWrap.']['title'] = htmlSpecialChars($strFileTitle);
            $arrConf['imageLightbox2.']['caption'] = str_repeat(chr(10), $this->cObj->singleCaption).htmlSpecialChars($strFileTitle);
            $arrConf['imageLightbox2.']['imageset'] = $arrRow['termin_order'];
            $found = TRUE;
            // New location types
        } elseif (is_array($arrRow) && count($arrRow)) {
            $queryParts = array(
                'SELECT' => 'FotoName',
                'FROM' => 'wp_Sto',
                'WHERE' => "GJ='".date('Y', strtotime($arrRow['termin_beginn']))."' AND OrtNr='".$arrRow['standort_ort']."' AND Paechter='".$arrRow['standort_paechter']."' AND StoNr='".$arrRow['standort_nummer']."' AND StoV='".$arrRow['standort_stelle']."' AND HS='".$arrRow['standort_h_anschlag']."' AND US='".$arrRow['standort_u_anschlag']."'",
            );
            $res = $this->db->exec_SELECT_queryArray($queryParts);
            if ($this->db->sql_num_rows($res) == 1) {
                $strFileName = current($this->db->sql_fetch_row($res));
                if (is_file($arrConf['file.']['import'].sprintf('%08d', $arrRow['standort_ort']).'/'.$arrRow['standort_paechter'].'/'.$strFileName.'.jpg')) {
                    $arrConf['file.']['import.']['override'] = sprintf('%08d', $arrRow['standort_ort']).'/'.$arrRow['standort_paechter'].'/'.$strFileName.'.jpg';
                    $arrConf['imageLinkWrap.']['title'] = htmlSpecialChars($strFileTitle);
                    $arrConf['imageLightbox2.']['caption'] = str_repeat(chr(10), $this->cObj->singleCaption).htmlSpecialChars($strFileTitle);
                    $arrConf['imageLightbox2.']['imageset'] = $arrRow['termin_order'];
                    $found = TRUE;
                }
            }
        }
        // The location does not exist
        if (!$found) {
            unset($arrConf['file.']['import.']);
            // $arrConf['imageLinkWrap'] = 0;
            $arrConf['imageLightbox2'] = 0;
            unset($arrConf['wrap']);
        }
        return (string)$this->cObj->cObjGetSingle($imageConf['cObject'], $arrConf, $this->prefixId);
    }

    /**
     * Creates the image for market plan of the given location
     *
     * @param	array		$arrRow: Array of the location data
     * @return	string		The Image of the given entry or the "nopic" picture
     */
    private function createImageMarket(array $arrRow) {
        $arrConf = $this->conf['locationImageMarket.'];
        $found = FALSE;
        // The location image exists
        $arrMarketImages = \TYPO3\CMS\Core\Utility\GeneralUtility::getFilesInDir($arrConf['file.']['import'], $GLOBALS['TYPO3_CONF_VARS']['GFX']['imagefile_ext']);
        foreach ($arrMarketImages as $strImageFile) {
            if (preg_match('/^'.$arrRow['standort_ekznr'].'_'.$arrRow['standort_paechter'].'_[a-zA-Z0-9]+\.[a-zA-Z0-9]+$/i', $strImageFile)) {
                $arrConf['file.']['import.']['override'] = $strImageFile;
                $arrConf['imageLinkWrap.']['title'] = htmlSpecialChars($arrRow['VMName']);
                $arrConf['imageLightbox2.']['caption'] = str_repeat(chr(10), $this->cObj->singleCaption).htmlSpecialChars($arrRow['VMName']);
                $arrConf['imageLightbox2.']['imageset'] = $arrRow['termin_order'];
                $found = TRUE;
                break;
            }
        }
        // The location does not exist exit 'nbsp' or the image
        return (!$found) ? '&nbsp;' : (string)$this->cObj->cObjGetSingle($this->conf['locationImageMarket'], $arrConf, $this->prefixId);
    }

    /**
     * Creates the mouseOver javascript programs
     *
     * @return	void
     */
    private function createMouseOver() {
        // Try to set the images
        if ($arrImgInfo = $this->cObj->getImgResource($this->conf['infoImage.']['file'], $this->conf['infoImage.']['file.']))	{
            $arrImgInfo[3] = \TYPO3\CMS\Core\Utility\GeneralUtility::png_to_gif_by_imagemagick($arrImgInfo[3]);
            if ($arrImgROInfo = $this->cObj->getImgResource($this->conf['infoImage.']['altFile'], $this->conf['infoImage.']['file.']))	{
                $arrImgROInfo[3] = \TYPO3\CMS\Core\Utility\GeneralUtility::png_to_gif_by_imagemagick($arrImgROInfo[3]);
                // Set the random image script
                $strImgName = 'img'.$GLOBALS['TSFE']->id.'_'.substr(md5($this->prefixId), 0, 4).'_0';
                $this->data['infoImage'] = $strImgName;
                $GLOBALS['TSFE']->setJS('mouseOver');
                //doemedia: Update javascript
                $GLOBALS['TSFE']->additionalJavaScript['tx_cawlogin_pi3'] .= chr(10).$strImgName.'_n=new Image(); '.$strImgName.'_n.src = "'.$GLOBALS['TSFE']->absRefPrefix.$arrImgInfo[3].'"; ';
                $GLOBALS['TSFE']->additionalJavaScript['tx_cawlogin_pi3'] .= chr(10).$strImgName.'_h=new Image(); '.$strImgName.'_h.src = "'.$GLOBALS['TSFE']->absRefPrefix.$arrImgROInfo[3].'"; ';
                //doemedia: Update javascript
            }
        }
    }

    /**
     * Creates the page navigation to list the next or previous locations
     *
     * @param	string		$content: The website content
     * @param	integer		$maxlinks: Number of maximal links listed
     * @return	string		The content with inserted page navigation
     */
    private function showPageNav($strContent, $intMaxlinks=10) {
        // Do not display the page navigation if not required
        if ($this->intTotal <= $this->conf['entriesPerPage']) {
            return $this->cObj->substituteSubpart($strContent, '###PAGENAV###', '');
        }
        // Calculate the count of the pages that are displayed
        $intPages = ceil($this->intTotal / $this->conf['entriesPerPage']);
        // Set start to "2"
        $intStart = 2;
        // Define the array with the marker
        $arrMarks = array(
            'current' => $this->piVars['page'],
            'first' => '1 ',
            'prev' => '',
            'last' => sprintf('%2d', $intPages),
            'next' => '',
            'pages' => '',
            'currentFirst' => '',
            'currentLast' => '',
        );
        // Current page is not the first one
        if ($this->piVars['page'] > 1) {
            $arrMarks['first'] = $this->pi_linkTP_keepPIvars('1', array('page' => 1, 'selectall' => '')).' ';
            $arrMarks['prev'] = $this->pi_linkTP_keepPIvars('&nbsp;', array('page' => $this->piVars['page'] - 1, 'selectall' => ''));
        }
        else {
            //$arrMarks['prev'] = $this->pi_linkTP_keepPIvars('&nbsp;', array('page' => $this->piVars['page'] - 1, 'selectall' => ''));
            $arrMarks['first'] = $this->pi_linkTP_keepPIvars('1', array('page' => 1, 'selectall' => '')).' ';
            $arrMarks['currentFirst'] = ' current';
        }

        // Current page is not the last one
        if ($intPages > $this->piVars['page']) {
            $arrMarks['last'] = $this->pi_linkTP_keepPIvars(sprintf('%2d', $intPages), array('page' => $intPages, 'selectall' => ''));
            $arrMarks['next'] = $this->pi_linkTP_keepPIvars('&nbsp;', array('page' => $this->piVars['page'] + 1, 'selectall' => ''));
        }
        else {
            $arrMarks['last'] = $this->pi_linkTP_keepPIvars(sprintf('%2d', $intPages), array('page' => $intPages, 'selectall' => ''));
            //$arrMarks['next'] = $this->pi_linkTP_keepPIvars('&nbsp;', array('page' => $this->piVars['page'] + 1, 'selectall' => ''));
            $arrMarks['currentLast'] = ' current';
        }

        // Current page ist greater than the half of max count
        if ($this->piVars['page'] > (ceil($intMaxlinks / 2) + 1) && $intPages > ($intMaxlinks + 1)) {
            $intStart = $this->piVars['page'] - ceil($intMaxlinks / 2) + 1;
            $arrMarks['first'] .= '...';
        }
        // Set the ending value to "all pages" or "max + start"
        $intEnd = min($intPages, $intStart + $intMaxlinks - 1);
        // Decrease the starting value
        if ($intStart > 2 && ($intEnd - $intStart + 1) < $intMaxlinks) {
            $intStart = max(2, $intEnd - $intMaxlinks + 1);
        }
        // Create the links
        for ($intI = $intStart; $intI < $intEnd; $intI++) {
            $page = $this->pi_linkTP_keepPIvars(sprintf('%2d', $intI), array('page' => $intI, 'selectall' => ''));

            if($intI == $this->piVars['page']) {
                $arrMarks['pages'] .= $this->cObj->stdWrap($page, $this->conf['pageNav.']['current.']);
            }
            else {
                $arrMarks['pages'] .= $this->cObj->stdWrap($page, $this->conf['pageNav.']['page.']);
            }
        }
        // There are further links at till the last page is reached
        if ($intEnd < $intPages) {
            $arrMarks['last'] = '...'.$arrMarks['last'];
        }
        // Get the template for displaying the buttons
        $strTemplate = $this->cObj->getSubpart($strContent, '###PAGENAV###');
        // Substitute the current marker
        $strTemplate = $this->cObj->substituteMarkerArray($strTemplate, $arrMarks, '###DATA_|###');
        // Replace the pagenav into the template
        return (string)$this->cObj->substituteSubpart($strContent, '###PAGENAV###', $strTemplate);
    }

    /**
     * Publicate the javascript code into the output content. Creates an temporary file if extension is not USER_INT, otherwise
     *
     * @return	void
     * @see		tx_cawlogin_pi:pi_TPLpublicateJavascript
     */
    protected function pi_TPLpublicateJavascript($strContent = "") {
        // Get the javascript template
        $strFileResource = $this->cObj->stdWrap($this->conf['javascriptFile'], $this->conf['javascriptFile.']);
        $strContent = $this->cObj->fileResource($strFileResource);
        $strContent = $this->cObj->getSubpart($strContent, '###'.$this->prefixId.'###');
        // Create array for substitution into javascript
        $this->data['ajaxUrl'] = $this->cObj->typolink_URL(array(
            'parameter' => $GLOBALS['TSFE']->id . ',100',
            'additionalParams' => '&tx_cawlogin_pi3[id]='.$GLOBALS['TSFE']->id . '&tx_cawlogin_pi3[ort]='.$this->piVars['ort'] . '&tx_cawlogin_pi3[checked]=1'
        ));
        $this->data['ajaxUrl'] .= '&type=100';
        $this->data['selectedUrl'] = $this->cObj->typolink_URL(array(
            'parameter' => $GLOBALS['TSFE']->id . ',102',
            'additionalParams' => '&tx_cawlogin_pi3[mode]=ajax&type=102'
        ));
        $this->data['selectedUrl'] .= '&type=102';

        // Substitute marker
        $strContent = $this->pi_TPLsubstituteDataMarker($strContent, $this->data);
        $strContent = $this->pi_TPLsubstituteLanguageMarker($strContent);

        $mapMarks = array(
            'URL' => $this->conf['marks.']['MAP_URL'],
            'ZOOM' => $this->conf['marks.']['MAP_ZOOM'],
            'CENTER_LAT' => $this->conf['marks.']['MAP_CENTER_LAT'],
            'CENTER_LNG' => $this->conf['marks.']['MAP_CENTER_LNG'],
            'ICON' => $this->cObj->cObjGetSingle($this->conf['marks.']['MAP_ICON'], $this->conf['marks.']['MAP_ICON.']),
            'ICON_TYPES' => $this->cObj->stdWrap($this->conf['marks.']['MAP_ICON_TYPES'], $this->conf['marks.']['MAP_ICON_TYPES.']),
            'TIMEOUT' => intval($this->conf['marks.']['MAP_TIMEOUT'])
        );
        $strContent = $this->cObj->substituteMarkerArray($strContent, $mapMarks, '###MAP_|###');

        parent::pi_TPLpublicateJavascript($strContent);
    }

    /**
     * Open connection to the external MySQL Database ´123data2`
     *
     * @param	string		$strHost: Database host
     * @param	string		$strUsername: Database username
     * @param	string		$strPassword: Database password
     * @param	string		$strDatabase: Database table
     * @return	void
     */
    private function pi3_DBconnect($strHost, $strUsername, $strPassword, $strDatabase)	{

        // Get an new instance for the database connection
        $this->db2 = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(\TYPO3\CMS\Core\Database\DatabaseConnection::class);
        // Debugging is enabled
        if (\TYPO3\CMS\Core\Utility\GeneralUtility::inList($this->conf['debug'], $_SERVER['REMOTE_ADDR'])) {
            $this->db2->debugOutput = $this->db2->store_lastBuiltQuery = TRUE;
        }

        $this->db2->setDatabaseHost($strHost);
        $this->db2->setDatabaseUsername($strUsername);
        $this->db2->setDatabasePassword($strPassword);
        $this->db2->setDatabaseName($strDatabase);
        $this->db2->setPersistentDatabaseConnection(true);
        $this->db2->setConnectionCompression(true);

        if ($this->db2->sql_pconnect($strHost, $strUsername, $strPassword))	{
            if (!$strDatabase)	{
                die('No database selected');
                exit;
            } elseif (!$this->db2->sql_select_db($strDatabase))	{
                die('Cannot connect to the current database, "'.$strDatabase.'"');
                exit;
            }
        } else {
            die('The current username, password or host was not accepted when the connection to the database was attempted to be established!');
            exit;
        }
    }
}


if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/cawlogin/plugins/pi3/class.tx_cawlogin_pi3.php'])	{
    include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/cawlogin/plugins/pi3/class.tx_cawlogin_pi3.php']);
}
