<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2008 Jan Roemich <jroemich@dpi-one.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/


/**
 * BUCHUNG ABSCHLIESSEN
 *
 *
 *
 *   71: class tx_cawlogin_pi6 extends tx_cawlogin_pi
 *
 *              SECTION: Main function
 *  113:     function init()
 *  139:     function main($content, $conf)
 *
 * TOTAL FUNCTIONS: 1
 *
 */























# require_once(PATH_t3lib.'class.t3lib_htmlmail.php');
require_once(\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath('cawlogin').'plugins/pi/class.tx_cawlogin_pi.php');


/**
 * Plugin 'CAW Complete order' for the 'cawlogin' extension.
 *
 * @author	Jan Roemich <jroemich@dpi-one.de>
 * @package	TYPO3
 * @subpackage	tx_cawlogin
 */
class tx_cawlogin_pi6 extends tx_cawlogin_pi {
    public $prefixId = 'tx_cawlogin_pi6';		// Same as class name
    public $scriptRelPath = 'plugins/pi6/class.tx_cawlogin_pi6.php';	// Path to this script relative to the extension dir.
    public $extKey = 'cawlogin';	// The extension key.
    private $strPath = 'uploads/tx_cawlogin/';
    /**
     * New instance of \TYPO3\CMS\Core\Mail\MailMessage::class
     *
     * @var \TYPO3\CMS\Core\Mail\MailMessage
     */
    var $objFormmail;





    /**
     * The main method of the PlugIn
     *
     * @param	string		$strContent: The PlugIn content
     * @param	array		$arrConf: The PlugIn configuration
     * @return	string		The content that is displayed on the website
     */
    public function main($strContent, array $arrConf)	{
        $this->conf = $arrConf;
        $this->pi_setPiVarDefaults();
        $this->pi_loadLL();
        $this->pi_USER_INT_obj = 1;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!
        $this->pi_initPIflexForm();



        // Main initialization
        parent::init();
        $strFileResource = $this->cObj->stdWrap($this->conf['templateFile'], $this->conf['templateFile.']);
        $strTemplate = $this->cObj->fileResource($strFileResource);
        $strTemplate = $this->cObj->getSubpart($strTemplate, '###'.$this->prefixId.'###');
        // Remove prices, if prices had not to be displayed

        $arrOrder = $this->pi_DBgetOrder();
        if (!$arrOrder['motiv_accepted'] && !empty($arrOrder['auftrag_motivordner']))  {
            $strTemplate = $this->cObj->getSubpart($strTemplate, 'MOTIFERROR');
            $strTemplate = $this->pi_TPLsubstituteFormularMarker($strTemplate);
            $strTemplate = $this->pi_TPLsubstituteLanguageMarker($strTemplate);
            return (string)$this->pi_wrapInBaseClass($strTemplate);
        }


        // The order is submitted
        if ($this->referer() && $this->piVars['submit']) {
            $this->sendTheMail();
            $this->storeDatabase();
            $this->pi_redirect($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'redirectOnSubmit'));
        }

        // Get the template

        // Load booking data from database
        $arrData = $this->getBookingData();
        $strContent = $this->cObj->getSubpart($strTemplate, !$this->pi_DBgetPartner() ? 'PARTNERERROR' : 'BOOKING');

        // Remove prices if prices had not to be displayed
        if (!$arrOrder['auftrag_preis']) {
            $strContent = $this->cObj->substituteSubpart($strContent, '###SHOWPRICE###', '', 1);
        } else {
            $strContent = preg_replace('@<!--[\s]+###SHOWPRICE###[\s]+[A-Z0-9\s]*?-->@si', '', $strContent);
        }

        // The order has been already send
        if ($intAlreadyBooked = $this->pi_DBgetLastBooking()) {
            $arrData['bookedDate'] = date('d.m.Y', $intAlreadyBooked);
            $arrData['bookedTime'] = date('H:i', $intAlreadyBooked);
        } else {
            $this->pi_LLset('alreadyBooked', '');
        }

        // Substitute language, formular and data marker
        $strContent = $this->pi_TPLsubstituteFormularMarker($strContent);
        $strContent = $this->pi_TPLsubstituteLanguageMarker($strContent);
        $strContent = $this->pi_TPLsubstituteDataMarker($strContent, $arrData);
        return (string)$this->pi_wrapInBaseClass($strContent);
    }

    /**
     * Return the booking data as an array to insert into the template
     *
     * @return	array		The needed data as an array
     */
    private function getBookingData() {
        $arrData = array(
            'bookings' => $this->pi_DBgetCount(0, 0, TRUE),
            'cities' => $this->pi_DBgetCountCities(0, TRUE),
            'price' => $this->pi_DBgetPrice(0, 0, TRUE, TRUE),
        );
        return (array)$arrData;
    }

    /**
     * Store the booking to database
     *
     * @return	void
     */
    private function storeDatabase() {
        $this->db->exec_UPDATEquery("Login_auftrag", "auftrag_nummer='".$this->session['ordernr']."'", array('auftrag_gebucht' => time()));
    }



    /**
     * Create and send all necessary emails
     *
     * @return	void
     */
    private function sendTheMail() {
        // Get required informations from database
        $arrData = array_merge((array)$this->pi_DBgetOrder(), (array)$this->pi_DBgetPartner());
        $arrData['auftrag_datum'] = strtotime($arrData['auftrag_datum']);
        $arrData['date'] = time();
        $arrData['remote_addr'] = \TYPO3\CMS\Core\Utility\GeneralUtility::getIndpEnv('REMOTE_ADDR');
        $showmotiv = !empty($arrData['poster']);
        if ($showmotiv) {
            if (!empty($arrData['poster']) && !preg_match('/^https?:\/\//i', $arrData['poster']))
                $arrData['poster'] = \TYPO3\CMS\Core\Utility\GeneralUtility::locationHeaderUrl($arrData['poster']);
            $arrData['poster'] = str_replace('https://', 'http://', $arrData['poster']);
            if (!empty($arrData['auftrag_mithintergrund'])) {
                $arrData['poster'] .= '&no_background=1';
            }
        } elseif (empty($arrData['poster'])) {
            $arrData['preview'] = '';
            $arrData['poster'] = '';
        }

        if ((int)$arrData['partner_alterauftrag'] < 1) $arrData['partner_alterauftrag'] = '###LL_unknown###';
        // Convert the information array to UTF-8
        while (list($strKey, $mixValue) = each($arrData)) $arrData[$strKey] = htmlspecialchars ($GLOBALS['TSFE']->csConv($mixValue, 'iso-8859-1'));

        // Create attachments
        $strFilename = $this->strPath.$arrData['auftrag_nummer'].'_';   //=> uploads/tx_cawlogin/123_
        $arrAttachments = array(
            'partner' => $this->pi_XLScreatePartner(0, $strFilename.$this->pi_getLL('fileNamePartner').'.xls'), //=> uploads/tx_cawlogin/123_Ansprechpartner.xls
            'complete' => $this->pi_XLScreateLocations(0, '', $strFilename.$this->pi_getLL('fileNameComplete').'.xls'),
            'booked' => $this->pi_XLScreateLocations(0, 'Gebucht', $strFilename.$this->pi_getLL('fileNameBooked').'.xls'),
            'removed' => $this->pi_XLScreateLocations(0, 'Entfernt', $strFilename.$this->pi_getLL('fileNameRemoved').'.xls'),
            'xml' =>  $this->pi_XMLcreateMotif(0, $this->strPath.$arrData['auftrag_nummer'].'.xml')
        );


        // Make new instance of t3lib_formmail => doemedia: \TYPO3\CMS\Core\Mail\MailMessage
        $this->objFormmail = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(\TYPO3\CMS\Core\Mail\MailMessage::class);

        // To email
        $email = \TYPO3\CMS\Core\Utility\GeneralUtility::trimExplode(chr(10), str_replace(',', chr(10), $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'to')), 1);
        if (!empty($arrData['auftrag_emailbetreuer'])) {
            $email = array($arrData['auftrag_emailbetreuer']);
        }

        // Get data from flexform for eMail headers
        $arrMarks = array(
            'from_name' => $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'fromName'),
            'from_email' => $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'from'),
            'subject' => $this->pi_TPLsubstituteDataMarker($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'subject'), $arrData),
            'recipient' => $email,
        );

        // doemedia begins
        $this->objFormmail->setFrom($arrMarks['from_email'], $arrMarks['from_name']);
        $this->objFormmail->setTo($email);
        $this->objFormmail->setSubject($arrMarks['subject']);
        // doemedia ends



        // Get the messages from pi_flexforms
        $strMessage = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'message');
        $strMessage = $this->pi_TPLsubstituteDataMarker($strMessage, $arrData);
        $strMessage = $this->pi_TPLsubstituteLanguageMarker($strMessage);


        $strMessage = $this->cObj->substituteSubpart($strMessage, '###ALREADYBOOKED###', $arrData['auftrag_gebucht'] ? $this->cObj->getSubpart($strMessage, '###ALREADYBOOKED###') : '');
        $strMessage = $this->cObj->substituteSubpart($strMessage, '###SHOWMOTIV###', $showmotiv ? $this->cObj->getSubpart($strMessage, '###SHOWMOTIV###') : '');
        $strMessage = $this->cObj->substituteSubpart($strMessage, '###SHOWMOTIVADD###', '');
        if ($GLOBALS['TSFE']->config['config']['formMailCharset'] || $GLOBALS['TSFE']->renderCharset != $GLOBALS['TSFE']->metaCharset) {
            $strMessage = $GLOBALS['TSFE']->csConvObj->conv($strMessage, $GLOBALS['TSFE']->renderCharset, $this->objFormmail->charset, 0);
        }

        // Add the message: doemedia
        $this->objFormmail->setBody($strMessage);
        // Add the attachments: doemedia
        $this->objFormmail->attach(\Swift_Attachment::fromPath(\TYPO3\CMS\Core\Utility\GeneralUtility::getFileAbsFileName($strFilename.$this->pi_getLL('fileNamePartner').'.xls')) );
        $this->objFormmail->attach(\Swift_Attachment::fromPath(\TYPO3\CMS\Core\Utility\GeneralUtility::getFileAbsFileName($strFilename.$this->pi_getLL('fileNameComplete').'.xls')));
        $this->objFormmail->attach(\Swift_Attachment::fromPath(\TYPO3\CMS\Core\Utility\GeneralUtility::getFileAbsFileName($strFilename.$this->pi_getLL('fileNameBooked').'.xls')) );
        $this->objFormmail->attach(\Swift_Attachment::fromPath(\TYPO3\CMS\Core\Utility\GeneralUtility::getFileAbsFileName($strFilename.$this->pi_getLL('fileNameRemoved').'.xls')) );
        $this->objFormmail->attach(\Swift_Attachment::fromPath(\TYPO3\CMS\Core\Utility\GeneralUtility::getFileAbsFileName($this->strPath.$arrData['auftrag_nummer'].'.xml')));

        if ($arrData['preview'] && file_exists('uploads/pics/'.$arrData['preview'])) {
//            $this->objFormmail->attach('uploads/pics/'.$arrData['preview'], $arrData['auftrag_nummer'].'_motivvorschau.jpg');
            //doemedia
//            $this->objFormmail->attach(\Swift_Attachment::fromPath(\TYPO3\CMS\Core\Utility\GeneralUtility::getFileAbsFileName($strFilename.'motivvorschau.jpg')));
            $this->objFormmail->attach(\Swift_Attachment::fromPath(\TYPO3\CMS\Core\Utility\GeneralUtility::getFileAbsFileName('uploads/pics/'.$arrData['preview'])));
        }

        // Send the mail
        $this->objFormmail->send();

;


        // doemedia
        $this->objFormmail->setTo($arrData['partner_email']);

        // Get the messages from pi_flexforms
        $strMessage = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'messageCustomer');
        $strMessage = $this->pi_TPLsubstituteDataMarker($strMessage, $arrData);
        $strMessage = $this->pi_TPLsubstituteLanguageMarker($strMessage);
        $strMessage = $this->cObj->substituteSubpart($strMessage, '###ALREADYBOOKED###', $arrData['auftrag_gebucht'] ? $this->cObj->getSubpart($strMessage, '###ALREADYBOOKED###') : '');
        $strMessage = $this->cObj->substituteSubpart($strMessage, '###SHOWMOTIV###', $showmotiv ? $this->cObj->getSubpart($strMessage, '###SHOWMOTIV###') : '');
        $strMessage = $this->cObj->substituteSubpart($strMessage, '###SHOWMOTIVADD###', '');

        if ($GLOBALS['TSFE']->config['config']['formMailCharset'] || $GLOBALS['TSFE']->renderCharset != $GLOBALS['TSFE']->metaCharset) {
            $strMessage = $GLOBALS['TSFE']->csConvObj->conv($strMessage, $GLOBALS['TSFE']->renderCharset, $this->objFormmail->charset, 0);
        }

        // Add the message
        // doemedia
        $this->objFormmail->setBody($strMessage);

        // Add the attachments
        // doemedia
        $this->objFormmail->attach(\Swift_Attachment::fromPath(\TYPO3\CMS\Core\Utility\GeneralUtility::getFileAbsFileName($strFilename.$this->pi_getLL('fileNamePartner').'.xls')));
        $this->objFormmail->attach(\Swift_Attachment::fromPath(\TYPO3\CMS\Core\Utility\GeneralUtility::getFileAbsFileName($strFilename.$this->pi_getLL('fileNameComplete').'.xls')));
        $this->objFormmail->attach(\Swift_Attachment::fromPath(\TYPO3\CMS\Core\Utility\GeneralUtility::getFileAbsFileName($strFilename.$this->pi_getLL('fileNameBooked').'.xls')));
        if ($arrData['preview'] && file_exists('uploads/pics/'.$arrData['preview'])) {
            $this->objFormmail->attach(\Swift_Attachment::fromPath(\TYPO3\CMS\Core\Utility\GeneralUtility::getFileAbsFileName($strFilename.'motivvorschau.jpg')));
        }
        // Send the mail
        $this->objFormmail->send();
        $GLOBALS['TT']->setTSlogMessage('"'.$this->prefixId.'" invoked, sending mail to "'.$arrData['partner_email'].'"', 0);

        // No Need to send to inteface operator
        if ($arrData['auftrag_schnittstelle'] == 'staudigl') {

            // Set new recipient
            $arrRecipient = \TYPO3\CMS\Core\Utility\GeneralUtility::trimExplode(chr(10), str_replace(',', chr(10), $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'toInterface')), TRUE);
            $this->objFormmail->setTo($arrRecipient);
            // Get the second message from pi_flexform
            $strMessage = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'messageInterface');
            $strMessage = $this->pi_TPLsubstituteDataMarker($strMessage, $arrData);
            $strMessage = $this->pi_TPLsubstituteLanguageMarker($strMessage);
            $strMessage = $this->cObj->substituteSubpart($strMessage, '###ALREADYBOOKED###', $arrData['auftrag_gebucht'] ? $this->cObj->getSubpart($strMessage, '###ALREADYBOOKED###') : '');
            $strMessage = $this->cObj->substituteSubpart($strMessage, '###SHOWMOTIV###', $showmotiv ? $this->cObj->getSubpart($strMessage, '###SHOWMOTIV###') : '');
            $strMessage = $this->cObj->substituteSubpart($strMessage, '###SHOWMOTIVADD###', '');

            if ($GLOBALS['TSFE']->config['config']['formMailCharset'] || $GLOBALS['TSFE']->renderCharset != $GLOBALS['TSFE']->metaCharset) {
                $strMessage = $GLOBALS['TSFE']->csConvObj->conv($strMessage, $GLOBALS['TSFE']->renderCharset, $this->objFormmail->charset, 0);
            }
            // Add the message
            $this->objFormmail->setBody($strMessage);
            // Add the attachments
            $arrAttachments['interface'] = $this->pi_XLScreateInterface(0, $strFilename.$this->pi_getLL('fileNameInterface').'.xls');
            $this->objFormmail->attach(\Swift_Attachment::fromPath(\TYPO3\CMS\Core\Utility\GeneralUtility::getFileAbsFileName($strFilename.$this->pi_getLL('fileNamePartner').'.xls')) );
            $this->objFormmail->attach(\Swift_Attachment::fromPath(\TYPO3\CMS\Core\Utility\GeneralUtility::getFileAbsFileName($this->strPath.$arrData['auftrag_nummer'].'.xml')));
            $this->objFormmail->attach(\Swift_Attachment::fromPath(\TYPO3\CMS\Core\Utility\GeneralUtility::getFileAbsFileName($strFilename.$this->pi_getLL('fileNameInterface').'.xls')) );
            if ($arrData['preview'] && file_exists('uploads/pics/'.$arrData['preview'])) {
//                $this->objFormmail->attach($strFilename.'_motivvorschau.jpg');
                $this->objFormmail->attach(\Swift_Attachment::fromPath(\TYPO3\CMS\Core\Utility\GeneralUtility::getFileAbsFileName('uploads/pics/'.$arrData['preview'])));
            }
            // Send the mail
            $this->objFormmail->send();
            $GLOBALS['TT']->setTSlogMessage('"Formmail" invoked, sending mail to "'.implode(', ', $arrRecipient).'"', 0);
        }

        foreach ($arrAttachments as $path) {
            if (file_exists( $path ) ) unlink( $path );
        }

    }
}


if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/cawlogin/plugins/pi6/class.tx_cawlogin_pi6.php'])	{
    include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/cawlogin/plugins/pi6/class.tx_cawlogin_pi6.php']);
}
